searchNodes=[{"type":"module","title":"Bonny","doc":"Extend the Kubernetes API and implement CustomResourceDefinitions lifecycles in Elixir.","ref":"Bonny.html"},{"type":"module","title":"Bonny.API.CRD","doc":"A Custom Resource Definition. The %Bonny.API.CRD{} struct contains the fields group , resource_type , scope and version . New definitions can be created directly, using the new!/1 function.","ref":"Bonny.API.CRD.html"},{"type":"function","title":"Bonny.API.CRD.fetch/2","doc":"See Map.fetch/2 .","ref":"Bonny.API.CRD.html#fetch/2"},{"type":"function","title":"Bonny.API.CRD.get/3","doc":"See Map.get/3 .","ref":"Bonny.API.CRD.html#get/3"},{"type":"function","title":"Bonny.API.CRD.get_and_update/3","doc":"See Map.get_and_update/3 .","ref":"Bonny.API.CRD.html#get_and_update/3"},{"type":"function","title":"Bonny.API.CRD.kind_to_names/2","doc":"Build a map of names form the given kind. Examples iex&gt; Bonny.API.CRD . kind_to_names ( &quot;SomeKind&quot; ) %{ singular : &quot;somekind&quot; , plural : &quot;somekinds&quot; , kind : &quot;SomeKind&quot; , shortNames : [ ] } The :inflex library is used to generate the plural form. iex&gt; Bonny.API.CRD . kind_to_names ( &quot;Hero&quot; ) %{ singular : &quot;hero&quot; , plural : &quot;heroes&quot; , kind : &quot;Hero&quot; , shortNames : [ ] } Accepts an optional list of abbreviations as second argument. iex&gt; Bonny.API.CRD . kind_to_names ( &quot;SomeKind&quot; , [ &quot;sk&quot; , &quot;some&quot; ] ) %{ singular : &quot;somekind&quot; , plural : &quot;somekinds&quot; , kind : &quot;SomeKind&quot; , shortNames : [ &quot;sk&quot; , &quot;some&quot; ] }","ref":"Bonny.API.CRD.html#kind_to_names/2"},{"type":"function","title":"Bonny.API.CRD.new!/1","doc":"Creates a new %Bonny.API.CRD{} struct from the given values. :scope is optional and defaults to :Namespaced .","ref":"Bonny.API.CRD.html#new!/1"},{"type":"function","title":"Bonny.API.CRD.to_manifest/1","doc":"Converts the internally used structure to a map representing a kubernetes CRD manifest.","ref":"Bonny.API.CRD.html#to_manifest/1"},{"type":"type","title":"Bonny.API.CRD.names_t/0","doc":"Defines the names section of the CRD. plural : name to be used in the URL: /apis/&lt;group&gt;/&lt;version&gt;/&lt;plural&gt; - e.g. crontabs singular : singular name to be used as an alias on the CLI and for display - e.g. crontab kind : is normally the CamelCased singular type. Your resource manifests use this. - e.g. CronTab shortnames : allow shorter string to match your resource on the CLI - e.g. [ct]","ref":"Bonny.API.CRD.html#t:names_t/0"},{"type":"type","title":"Bonny.API.CRD.t/0","doc":"A Custom Resource Definition. scope : either Namespaced or Cluster group : group name to use for REST API: /apis/&lt;group&gt;/&lt;version&gt;, defaults to the group in config.exs names : see names_t versions : list of API Version modules for this Resource, defaults to the versions in config.exs","ref":"Bonny.API.CRD.html#t:t/0"},{"type":"module","title":"Bonny.API.ResourceEndpoint","doc":"Defines the API Endpoint for a Kubernetes resource. The struct contains the fields group , resource_type , scope and version . New definitions can be created directly or using the new!/1 function.","ref":"Bonny.API.ResourceEndpoint.html"},{"type":"function","title":"Bonny.API.ResourceEndpoint.new!/1","doc":"Creates a new %Bonny.API.ResourceEndpoint{} struct from the given values. :scope is optional and defaults to :Namespaced .","ref":"Bonny.API.ResourceEndpoint.html#new!/1"},{"type":"function","title":"Bonny.API.ResourceEndpoint.new!/3","doc":"Creates a new %Bonny.API.ResourceEndpoint{} struct from apiVersion and kind . The scope can be passed as a third optional parameter. Examples iex&gt; Bonny.API.ResourceEndpoint . new! ( &quot;apps/v1&quot; , &quot;Deployment&quot; ) % Bonny.API.ResourceEndpoint { group : &quot;apps&quot; , resource_type : &quot;deployments&quot; , scope : :Namespaced , version : &quot;v1&quot; } iex&gt; Bonny.API.ResourceEndpoint . new! ( &quot;v1&quot; , &quot;Pod&quot; ) % Bonny.API.ResourceEndpoint { group : nil , resource_type : &quot;pods&quot; , scope : :Namespaced , version : &quot;v1&quot; } iex&gt; Bonny.API.ResourceEndpoint . new! ( &quot;rbac.authorization.k8s.io/v1&quot; , &quot;ClusterRoleBinding&quot; , :Cluster ) % Bonny.API.ResourceEndpoint { group : &quot;rbac.authorization.k8s.io&quot; , resource_type : &quot;clusterrolebindings&quot; , scope : :Cluster , version : &quot;v1&quot; } iex&gt; Bonny.API.ResourceEndpoint . new! ( &quot;foo/bar/v1&quot; , &quot;ClusterRoleBinding&quot; , :Cluster ) ** (ArgumentError) The api_version &quot;foo/bar/v1&quot; cannot be parsed. It contains more than one slash (/).","ref":"Bonny.API.ResourceEndpoint.html#new!/3"},{"type":"function","title":"Bonny.API.ResourceEndpoint.resource_api_version/1","doc":"Gets apiVersion of the actual resources. Examples Returns apiVersion for an operator iex&gt; Bonny.API.ResourceEndpoint . resource_api_version ( % Bonny.API.ResourceEndpoint { group : &quot;hello.example.com&quot; , version : &quot;v1&quot; , scope : :namespaced , resource_type : &quot;foos&quot; } ) &quot;hello.example.com/v1&quot; Returns apiVersion for apps resources iex&gt; Bonny.API.ResourceEndpoint . resource_api_version ( % Bonny.API.ResourceEndpoint { group : &quot;apps&quot; , version : &quot;v1&quot; , scope : :namespaced , resource_type : &quot;foos&quot; } ) &quot;apps/v1&quot; Returns apiVersion for core resources iex&gt; Bonny.API.ResourceEndpoint . resource_api_version ( % Bonny.API.ResourceEndpoint { group : &quot;&quot; , version : &quot;v1&quot; , scope : :namespaced , resource_type : &quot;foos&quot; } ) &quot;v1&quot; iex&gt; Bonny.API.ResourceEndpoint . resource_api_version ( % Bonny.API.ResourceEndpoint { group : nil , version : &quot;v1&quot; , scope : :namespaced , resource_type : &quot;foos&quot; } ) &quot;v1&quot;","ref":"Bonny.API.ResourceEndpoint.html#resource_api_version/1"},{"type":"type","title":"Bonny.API.ResourceEndpoint.t/0","doc":"A Resource API Definition. Also see Kubernetes API terminology . group : The API group used for REST API: /apis/&lt;group&gt;/&lt;version&gt;, e.g. &quot;apps&quot; or &quot;example.com&quot; resource_type : The plural form of the resource name scope : :Namespaced or :Cluster - defaults to :Namespaced version : The API version used for REST API: /apis/&lt;group&gt;/&lt;version&gt;, e.g. &quot;v1&quot; or &quot;v1alpha1&quot;","ref":"Bonny.API.ResourceEndpoint.html#t:t/0"},{"type":"behaviour","title":"Bonny.API.Version","doc":"Describes an API version of a custom resource. The %Bonny.API.Version{} struct contains the fields required to build the manifest for this version. This module is meant to be use d by a module representing the API version of a custom resource. The using module has to define the function manifest/0 . The macro defaults/1 is imported to the using module. It can be used to simplify getting started. The first argument is the version's name (e.g. &quot;v1&quot;). If no name is passed, The macro will use the using module's name as the version name. Note: The :storage flag has to be true for exactly one version of a CRD. defmodule MyOperator.API.V1.CronTab do use Bonny.API.Version def manifest ( ) do struct! ( defaults ( ) , storage : true ) end Use the manifest/0 callback to override the defaults, e.g. add a schema. Pipe your struct into add_observed_generation_status/1 - which is imported into the using module - if you use the Bonny.Pluggable.SkipObservedGenerations step in your controller defmodule MyOperator.API.V1.CronTab do use Bonny.API.Version def manifest ( ) do struct! ( defaults ( ) , storage : true , schema : % { openAPIV3Schema : %{ type : :object , properties : %{ spec : %{ } } } ) end","ref":"Bonny.API.Version.html"},{"type":"function","title":"Bonny.API.Version.add_conditions/1","doc":"Adds the status subresource if it hasn't been added before and adds the schema for the .status.conditions array. Example iex&gt; % Bonny.API.Version { } ...&gt; |&gt; Bonny.API.Version . add_conditions ( ) ...&gt; |&gt; Map . take ( [ :subresources , :schema ] ) %{ subresources : %{ status : %{ } } , schema : %{ openAPIV3Schema : %{ type : :object , properties : %{ status : %{ type : :object , properties : %{ conditions : %{ type : :array , items : %{ type : :object , properties : %{ type : %{ type : :string } , status : %{ type : :string , enum : [ &quot;True&quot; , &quot;False&quot; ] } , message : %{ type : :string } , lastTransitionTime : %{ type : :string , format : :&quot;date-time&quot; } , lastHeartbeatTime : %{ type : :string , format : :&quot;date-time&quot; } } } } } } } , &quot;x-kubernetes-preserve-unknown-fields&quot; : true , } } }","ref":"Bonny.API.Version.html#add_conditions/1"},{"type":"function","title":"Bonny.API.Version.add_observed_generation_status/1","doc":"Adds the status subresource if it hasn't been added before and adds a field .status.observedGeneration of type integer to the OpenAPIV3Schema. Example iex&gt; % Bonny.API.Version { } ...&gt; |&gt; Bonny.API.Version . add_observed_generation_status ( ) ...&gt; |&gt; Map . take ( [ :subresources , :schema ] ) %{ subresources : %{ status : %{ } } , schema : %{ openAPIV3Schema : %{ type : :object , properties : %{ status : %{ type : :object , properties : %{ observedGeneration : %{ type : :integer } } } } , &quot;x-kubernetes-preserve-unknown-fields&quot; : true , } } }","ref":"Bonny.API.Version.html#add_observed_generation_status/1"},{"type":"macro","title":"Bonny.API.Version.defaults/0","doc":"Returns a Bonny.API.Version struct with default values. Use this and pipe it into struct!() to override the defaults in your manifest/0 callback.","ref":"Bonny.API.Version.html#defaults/0"},{"type":"callback","title":"Bonny.API.Version.manifest/0","doc":"Return a %Bonny.API.Version{} struct representing the manifest for this version of the CRD API.","ref":"Bonny.API.Version.html#c:manifest/0"},{"type":"type","title":"Bonny.API.Version.printer_column_t/0","doc":"Defines an additional printer column .","ref":"Bonny.API.Version.html#t:printer_column_t/0"},{"type":"type","title":"Bonny.API.Version.schema_t/0","doc":"Defines an OpenAPI V3 Schema . The typespec might be incomplete. Please open a PR with your additions and links to the relevant documentation, thanks.","ref":"Bonny.API.Version.html#t:schema_t/0"},{"type":"type","title":"Bonny.API.Version.subresources_t/0","doc":"Defines a version of a custom resource. Refer to the CRD versioning documentation","ref":"Bonny.API.Version.html#t:subresources_t/0"},{"type":"type","title":"Bonny.API.Version.t/0","doc":"","ref":"Bonny.API.Version.html#t:t/0"},{"type":"module","title":"Bonny.Axn","doc":"Describes a resource action event. This is the token passed to all steps of your operator and controller pipeline. This module gets imported to your controllers where you should use the functions register_descendant/3 , update_status/2 and the ones to register events: success_event/2 , failure_event/2 and/or register_event/6 . Note that these functions raise exceptions if those resources have already been applied to the cluster. The register_before_* functions can be used in Pluggable steps in order to register callbacks that are called before applying resources to the cluster. Have a look at Bonny.Pluggable.Logger for a use case. Action event fields These fields contain information on the action event that occurred. action - the action that triggered this event resource - the resource the action was applied to conn - the connection to the cluster the event occurred operator - the operator that discovered and dispatched the event controller - the controller handling the event and its init opts Reaction fields descendants - descending resources defined by the handling controller status - the data to be applied to the status subresource events - Kubernetes events regarding the resource to be applied to the cluster Pipeline fields halted - the boolean status on whether the pipeline was halted assigns - shared user data as a map private - shared library data as a map states - The states for status, events and descendants","ref":"Bonny.Axn.html"},{"type":"function","title":"Bonny.Axn.apply_descendants/2","doc":"Applies the dependants to the cluster. If :create_events is true, will create an event for each successful apply. Always creates events upon failed applies. Options :create_events - Whether events should be created upon success. Defaults to true All further options are passed to K8s.Client.apply/2","ref":"Bonny.Axn.html#apply_descendants/2"},{"type":"function","title":"Bonny.Axn.apply_status/2","doc":"Applies the status to the resource's status subresource in the cluster. If no status was specified, :noop is returned.","ref":"Bonny.Axn.html#apply_status/2"},{"type":"macro","title":"Bonny.Axn.are_descendants_applied/1","doc":"","ref":"Bonny.Axn.html#are_descendants_applied/1"},{"type":"macro","title":"Bonny.Axn.are_events_emitted/1","doc":"","ref":"Bonny.Axn.html#are_events_emitted/1"},{"type":"function","title":"Bonny.Axn.clear_events/1","doc":"Empties the list of events without emitting them.","ref":"Bonny.Axn.html#clear_events/1"},{"type":"function","title":"Bonny.Axn.emit_events/1","doc":"Emits the events created for this Axn.","ref":"Bonny.Axn.html#emit_events/1"},{"type":"function","title":"Bonny.Axn.failure_event/2","doc":"Registers a failure event to the %Axn{} token to be emitted by Bonny.","ref":"Bonny.Axn.html#failure_event/2"},{"type":"function","title":"Bonny.Axn.identifier/1","doc":"Returns an identifier of an action event (resource and action) as tuple. Can be used in logs and similar.","ref":"Bonny.Axn.html#identifier/1"},{"type":"macro","title":"Bonny.Axn.is_status_applied/1","doc":"","ref":"Bonny.Axn.html#is_status_applied/1"},{"type":"function","title":"Bonny.Axn.new!/1","doc":"","ref":"Bonny.Axn.html#new!/1"},{"type":"function","title":"Bonny.Axn.register_after_processed/2","doc":"Registers a callback to be invoked at the very end of an action event's processing by the operator. Callbacks are invoked in the reverse order they are defined (callbacks defined first are invoked last). Examples To log a message after the an event was processed by the operator: Bonny.Axn . register_after_processed ( axn , fn axn -&gt; Logger . info ( &quot;done&quot; ) axn end )","ref":"Bonny.Axn.html#register_after_processed/2"},{"type":"function","title":"Bonny.Axn.register_before_apply_descendants/2","doc":"Registers a callback to be invoked before descendants are applied to the cluster. Callbacks are invoked in the reverse order they are defined (callbacks defined first are invoked last). Examples To log a message: require Logger Bonny.Axn . register_before_apply_status ( axn , fn descendants , axn -&gt; Enum . each ( descendants , &amp; Logger . info ( &quot;Descending \#{ &amp;1 [ &quot;kind&quot; ] } named \#{ &amp;1 [ &quot;name&quot; ] } is applied to namespace \#{ &amp;1 [ &quot;metadata&quot; ] [ &quot;namespace&quot; ] } &quot; ) ) descendants end )","ref":"Bonny.Axn.html#register_before_apply_descendants/2"},{"type":"function","title":"Bonny.Axn.register_before_apply_status/2","doc":"Registers a callback to be invoked before a status is applied to the status subresource. Callbacks are invoked in the reverse order they are defined (callbacks defined first are invoked last). Examples To log a message for the status being applied: require Logger Bonny.Axn . register_before_apply_status ( axn , fn resource , axn -&gt; Logger . info ( &quot;Status of the \#{ resource [ &quot;kind&quot; ] } named \#{ resource [ &quot;metadata&quot; ] [ &quot;name&quot; ] } is applied to namespace \#{ resource [ &quot;metadata&quot; ] [ &quot;namespace&quot; ] } &quot; ) resource end )","ref":"Bonny.Axn.html#register_before_apply_status/2"},{"type":"function","title":"Bonny.Axn.register_before_emit_event/2","doc":"Registers a callback to be invoked before events are emitted to the cluster. Callbacks are invoked in the reverse order they are defined (callbacks defined first are invoked last). Examples To log a message: require Logger Bonny.Axn . register_before_apply_status ( axn , fn events , axn -&gt; Logger . info ( &quot;Event of type \#{ event . event_type } is emitted&quot; ) events end )","ref":"Bonny.Axn.html#register_before_emit_event/2"},{"type":"function","title":"Bonny.Axn.register_descendant/3","doc":"Registers a decending object to be applied. Owner reference will be added automatically. Adding the owner reference can be disabled by passing the option omit_owner_ref: true .","ref":"Bonny.Axn.html#register_descendant/3"},{"type":"function","title":"Bonny.Axn.register_event/6","doc":"Registers a Kubernetes event to the %Axn{} token to be emitted by Bonny.","ref":"Bonny.Axn.html#register_event/6"},{"type":"function","title":"Bonny.Axn.set_condition/4","doc":"Sets the condition in the resource status. The field .status.conditions , if configured in the CRD, nolds a list of conditions, their status with a message and two timestamps. On the resource this could look something like this (taken from a Pod): kind : Pod status : conditions : - lastTransitionTime : &quot;2019-10-22T16:29:24Z&quot; status : &quot;True&quot; type : PodScheduled - lastTransitionTime : &quot;2019-10-22T16:29:24Z&quot; status : &quot;True&quot; type : Initialized - lastTransitionTime : &quot;2019-10-22T16:29:31Z&quot; status : &quot;True&quot; type : ContainersReady - lastTransitionTime : &quot;2019-10-22T16:29:31Z&quot; status : &quot;True&quot; type : Ready","ref":"Bonny.Axn.html#set_condition/4"},{"type":"function","title":"Bonny.Axn.success_event/2","doc":"Registers a asuccess event to the %Axn{} token to be emitted by Bonny.","ref":"Bonny.Axn.html#success_event/2"},{"type":"function","title":"Bonny.Axn.update_status/2","doc":"Executes fun for the resource status and applies the new status subresource. This can be called multiple times. fun should be a function of arity 1. It will be passed the current status object and expected to return the updated one. If no current status exists, an empty map is passed to fun","ref":"Bonny.Axn.html#update_status/2"},{"type":"type","title":"Bonny.Axn.assigns/0","doc":"","ref":"Bonny.Axn.html#t:assigns/0"},{"type":"type","title":"Bonny.Axn.states/0","doc":"","ref":"Bonny.Axn.html#t:states/0"},{"type":"type","title":"Bonny.Axn.t/0","doc":"","ref":"Bonny.Axn.html#t:t/0"},{"type":"module","title":"Bonny.Axn.Test","doc":"Conveniences for testing Axn steps. This module can be used in your test cases, like this: use ExUnit.Case , async : true use Bonny.Axn.Test Using this module will: import all the functions from this module import all the functions from the Bonny.Axn module import all the functions from the Pluggable.Token module","ref":"Bonny.Axn.Test.html"},{"type":"function","title":"Bonny.Axn.Test.assigns/1","doc":"","ref":"Bonny.Axn.Test.html#assigns/1"},{"type":"function","title":"Bonny.Axn.Test.axn/2","doc":"","ref":"Bonny.Axn.Test.html#axn/2"},{"type":"function","title":"Bonny.Axn.Test.descendants/1","doc":"","ref":"Bonny.Axn.Test.html#descendants/1"},{"type":"function","title":"Bonny.Axn.Test.events/1","doc":"","ref":"Bonny.Axn.Test.html#events/1"},{"type":"function","title":"Bonny.Axn.Test.status/1","doc":"","ref":"Bonny.Axn.Test.html#status/1"},{"type":"module","title":"Bonny.CRD","doc":"Represents the spec portion of a Kubernetes CustomResourceDefinition manifest. The CustomResourceDefinition API resource allows you to define custom resources. Defining a CRD object creates a new custom resource with a name and schema that you specify. The Kubernetes API serves and handles the storage of your custom resource.","ref":"Bonny.CRD.html"},{"type":"function","title":"Bonny.CRD.api_version/1","doc":"Gets group version from CRD spec Examples Returns apiVersion for an operator iex&gt; Bonny.CRD . api_version ( % Bonny.CRD { group : &quot;hello.example.com&quot; , version : &quot;v1&quot; , scope : :namespaced , names : %{ } } ) &quot;hello.example.com/v1&quot; Returns apiVersion for apps resources iex&gt; Bonny.CRD . api_version ( % Bonny.CRD { group : &quot;apps&quot; , version : &quot;v1&quot; , scope : :namespaced , names : %{ } } ) &quot;apps/v1&quot; Returns apiVersion for core resources iex&gt; Bonny.CRD . api_version ( % Bonny.CRD { group : &quot;&quot; , version : &quot;v1&quot; , scope : :namespaced , names : %{ } } ) &quot;v1&quot; iex&gt; Bonny.CRD . api_version ( % Bonny.CRD { group : nil , version : &quot;v1&quot; , scope : :namespaced , names : %{ } } ) &quot;v1&quot;","ref":"Bonny.CRD.html#api_version/1"},{"type":"function","title":"Bonny.CRD.default_columns/0","doc":"Default CLI printer columns. These are added to the CRDs columns when columns are set. The kubernetes API returns these by default when they are not set.","ref":"Bonny.CRD.html#default_columns/0"},{"type":"function","title":"Bonny.CRD.kind/1","doc":"CRD Kind or plural name Examples iex&gt; Bonny.CRD . kind ( % Bonny.CRD { names : %{ plural : &quot;greetings&quot; } , scope : :namespaced , group : &quot;test&quot; , version : &quot;v1&quot; } ) &quot;greetings&quot;","ref":"Bonny.CRD.html#kind/1"},{"type":"function","title":"Bonny.CRD.to_manifest/2","doc":"Generates the map equivalent of the Kubernetes CRD YAML manifest --- apiVersion: apiextensions.k8s.io/v1beta1 kind: CustomResourceDefinition metadata: creationTimestamp: null name: widgets.example.com spec: group: example.com names: kind: Widget plural: widgets scope: Namespaced version: v1","ref":"Bonny.CRD.html#to_manifest/2"},{"type":"type","title":"Bonny.CRD.t/0","doc":"CRD Spec","ref":"Bonny.CRD.html#t:t/0"},{"type":"module","title":"Bonny.Config","doc":"Operator configuration interface","ref":"Bonny.Config.html"},{"type":"function","title":"Bonny.Config.api_version/0","doc":"Kubernetes APIVersion used. Defaults to apiextensions.k8s.io/v1","ref":"Bonny.Config.html#api_version/0"},{"type":"function","title":"Bonny.Config.conn/0","doc":"K8s.Conn name used for this operator.","ref":"Bonny.Config.html#conn/0"},{"type":"function","title":"Bonny.Config.controllers/0","doc":"List of all controller modules to watch. This must be set in config.exs: config :bonny , controllers : [ MyController1 , MyController2 ]","ref":"Bonny.Config.html#controllers/0"},{"type":"function","title":"Bonny.Config.group/0","doc":"Kubernetes API Group of this operator","ref":"Bonny.Config.html#group/0"},{"type":"function","title":"Bonny.Config.instance_name/0","doc":"The name of the operator instance. This is set via environment variable BONNY_POD_NAME","ref":"Bonny.Config.html#instance_name/0"},{"type":"function","title":"Bonny.Config.labels/0","doc":"Labels to apply to all operator resources. Note: These are only applied to the resources that compose the operator itself, not the resources created by the operator. This can be set in config.exs: config :bonny , labels : %{ foo : &quot;bar&quot; , quz : &quot;baz&quot; }","ref":"Bonny.Config.html#labels/0"},{"type":"function","title":"Bonny.Config.name/0","doc":"The name of the operator. Name must consist of only lowercase letters and hyphens. Defaults to hyphenated mix project app name. E.g.: :hello_operator becomes hello-operator","ref":"Bonny.Config.html#name/0"},{"type":"function","title":"Bonny.Config.namespace/0","doc":"The namespace to watch for Namespaced CRDs. Defaults to default This can be set via environment variable: BONNY_POD_NAMESPACE=prod # specific namespace # or BONNY_POD_NAMESPACE=__ALL__ # all namespaces iex -S mix Or via config.exs: config :bonny , namespace : &quot;mynamespace&quot; # specific namespace # or config :bonny ; namespace : :all # all namespaces Configuration via environment variable always takes precedence over config.exs. Bonny sets BONNY_POD_NAMESPACE on all Kubernetes deployments to the namespace the operator is deployed in.","ref":"Bonny.Config.html#namespace/0"},{"type":"function","title":"Bonny.Config.service_account/0","doc":"Kubernetes service account name to run operator as. Note: if a kube config file is provided, this service account will still be created and assigned to pods, but the config file auth will be used when making requests to the Kube API. Name must consist of only lowercase letters and hyphens. Defaults to hyphenated mix project app name. E.g.: :hello_operator becomes hello-operator","ref":"Bonny.Config.html#service_account/0"},{"type":"function","title":"Bonny.Config.versions/0","doc":"Kubernetes API Versions of this operator","ref":"Bonny.Config.html#versions/0"},{"type":"behaviour","title":"Bonny.Controller","doc":"Bonny.Controller defines controller behaviours and generates boilerplate for generating Kubernetes manifests. A custom controller is a controller that users can deploy and update on a running cluster, independently of the cluster’s own lifecycle. Custom controllers can work with any kind of resource, but they are especially effective when combined with custom resources. The Operator pattern is one example of such a combination. It allows developers to encode domain knowledge for specific applications into an extension of the Kubernetes API. Controllers allow for simple add , modify , delete , and reconcile handling of custom resources in the Kubernetes API.","ref":"Bonny.Controller.html"},{"type":"callback","title":"Bonny.Controller.add/1","doc":"","ref":"Bonny.Controller.html#c:add/1"},{"type":"callback","title":"Bonny.Controller.conn/0","doc":"Bonny.Controller comes with a default implementation which returns Bonny.Config.config()","ref":"Bonny.Controller.html#c:conn/0"},{"type":"callback","title":"Bonny.Controller.delete/1","doc":"","ref":"Bonny.Controller.html#c:delete/1"},{"type":"function","title":"Bonny.Controller.ensure_list_query/1","doc":"","ref":"Bonny.Controller.html#ensure_list_query/1"},{"type":"function","title":"Bonny.Controller.ensure_watch_query/1","doc":"","ref":"Bonny.Controller.html#ensure_watch_query/1"},{"type":"callback","title":"Bonny.Controller.list_operation/0","doc":"Should return an operation to list resources for watching and reconciliation. Bonny.Controller comes with a default implementation","ref":"Bonny.Controller.html#c:list_operation/0"},{"type":"function","title":"Bonny.Controller.list_operation/1","doc":"","ref":"Bonny.Controller.html#list_operation/1"},{"type":"callback","title":"Bonny.Controller.modify/1","doc":"","ref":"Bonny.Controller.html#c:modify/1"},{"type":"callback","title":"Bonny.Controller.reconcile/1","doc":"","ref":"Bonny.Controller.html#c:reconcile/1"},{"type":"behaviour","title":"Bonny.ControllerV2","doc":"Controllers handle action events observed by a resource watch query. Controllers must be registered at the operator together with the resource watch query. The operator will then delegate events observed by that query for processing to this controller Controllers use the Pluggable.StepBuilder to build a step in the processing pipeline. In order to use it, a step has to be defined and implemented in the controller. The step must have the following spec step_name ( Bonny.Axn . t ( ) , keyword ( ) ) :: Bonny.Axn . t ( ) The modules Bonny.Axn module is imported to your controller. In your event handler step you should use the functions Bonny.Axn.register_descendant/3 , Bonny.Axn.update_status/2 and the ones to register events: Bonny.Axn.success_event/2 , Bonny.Axn.failure_event/2 and/or Bonny.Axn.register_event/6 . Note that these functions raise exceptions if those resources have already been applied to the cluster. Example Match against the struct's :action field which is one of :add , :modify , :reconcile or :delete to provide an implementation for each case. defmodule MyOperator.Controller.CronTabController do # other steps step :handle_event # other steps # apply the resource def handle_event ( % Bonny.Axn { action : action , resource : resource } = axn , _opts ) when action in [ :add , :modify , :reconcile ] do success_event ( axn ) end def handle_event ( % Bonny.Axn { action : :delete , resource : resource } = axn , _opts ) do # axn end end Registering your descendants with the %Bonny.Axn{} token makes your controller easier to test. Be sure to add Bonny.Pluggable.ApplyDescendants as step to your operator in order for the descendants to be applied to the cluster. defmodule MyOperator.Controller.CronTabController do # other steps step :handle_event # other steps # apply the resource def handle_event ( axn , _opts ) do deployment = generate_deployment ( axn . resource ) axn |&gt; register_descendant ( deployment ) |&gt; success_event ( ) end end Use Bonny.Axn.update_status/2 to store API responses or other status data in the resource status. Be sure to enable the status subresource in your CRD version module. defmodule MyOperator.Controller.CronTabController do # other steps step :handle_event # other steps # apply the resource def handle_event ( axn , _opts ) do response = apply_state ( axn . resource ) axn |&gt; update_status ( fn status -&gt; Map . put ( status , &quot;response&quot; , response ) end ) |&gt; success_event ( ) end end","ref":"Bonny.ControllerV2.html"},{"type":"function","title":"Bonny.ControllerV2.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Bonny.ControllerV2.html#child_spec/1"},{"type":"callback","title":"Bonny.ControllerV2.rbac_rules/0","doc":"","ref":"Bonny.ControllerV2.html#c:rbac_rules/0"},{"type":"function","title":"Bonny.ControllerV2.start_link/1","doc":"","ref":"Bonny.ControllerV2.html#start_link/1"},{"type":"function","title":"Bonny.ControllerV2.to_rbac_rule/1","doc":"","ref":"Bonny.ControllerV2.html#to_rbac_rule/1"},{"type":"type","title":"Bonny.ControllerV2.api/0","doc":"","ref":"Bonny.ControllerV2.html#t:api/0"},{"type":"type","title":"Bonny.ControllerV2.rbac_rule/0","doc":"","ref":"Bonny.ControllerV2.html#t:rbac_rule/0"},{"type":"type","title":"Bonny.ControllerV2.resource/0","doc":"","ref":"Bonny.ControllerV2.html#t:resource/0"},{"type":"type","title":"Bonny.ControllerV2.verb/0","doc":"","ref":"Bonny.ControllerV2.html#t:verb/0"},{"type":"module","title":"Bonny.Event","doc":"Represents a kubernetes event. Documentation: https://kubernetes.io/docs/reference/kubernetes-api/cluster-resources/event-v1/","ref":"Bonny.Event.html"},{"type":"function","title":"Bonny.Event.new!/1","doc":"Creates an event. Options: :reporting_controller , :reporting_instance","ref":"Bonny.Event.html#new!/1"},{"type":"function","title":"Bonny.Event.new!/7","doc":"","ref":"Bonny.Event.html#new!/7"},{"type":"type","title":"Bonny.Event.event_type/0","doc":"Kubernetes events currently support these types.","ref":"Bonny.Event.html#t:event_type/0"},{"type":"type","title":"Bonny.Event.t/0","doc":"See https://kubernetes.io/docs/reference/kubernetes-api/cluster-resources/event-v1/ for field explanations.","ref":"Bonny.Event.html#t:t/0"},{"type":"module","title":"Bonny.EventRecorder","doc":"Records kubernetes events regarding objects controlled by this operator.","ref":"Bonny.EventRecorder.html"},{"type":"function","title":"Bonny.EventRecorder.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Bonny.EventRecorder.html#child_spec/1"},{"type":"function","title":"Bonny.EventRecorder.emit/3","doc":"Create a kubernetes event in the cluster. Documentation: https://kubernetes.io/docs/reference/kubernetes-api/cluster-resources/event-v1/","ref":"Bonny.EventRecorder.html#emit/3"},{"type":"function","title":"Bonny.EventRecorder.start_link/1","doc":"","ref":"Bonny.EventRecorder.html#start_link/1"},{"type":"type","title":"Bonny.EventRecorder.event_key/0","doc":"A map to identify an event.","ref":"Bonny.EventRecorder.html#t:event_key/0"},{"type":"module","title":"Bonny.Mix.Operator","doc":"Encapsulates Kubernetes resource manifests for an operator","ref":"Bonny.Mix.Operator.html"},{"type":"function","title":"Bonny.Mix.Operator.cluster_role/1","doc":"ClusterRole manifest","ref":"Bonny.Mix.Operator.html#cluster_role/1"},{"type":"function","title":"Bonny.Mix.Operator.cluster_role_binding/1","doc":"ClusterRoleBinding manifest","ref":"Bonny.Mix.Operator.html#cluster_role_binding/1"},{"type":"function","title":"Bonny.Mix.Operator.crds/1","doc":"CRD manifests","ref":"Bonny.Mix.Operator.html#crds/1"},{"type":"function","title":"Bonny.Mix.Operator.deployment/2","doc":"Deployment manifest","ref":"Bonny.Mix.Operator.html#deployment/2"},{"type":"function","title":"Bonny.Mix.Operator.find_operators/0","doc":"","ref":"Bonny.Mix.Operator.html#find_operators/0"},{"type":"function","title":"Bonny.Mix.Operator.rbac_rules/1","doc":"","ref":"Bonny.Mix.Operator.html#rbac_rules/1"},{"type":"function","title":"Bonny.Mix.Operator.service_account/1","doc":"ServiceAccount manifest","ref":"Bonny.Mix.Operator.html#service_account/1"},{"type":"module","title":"Bonny.Naming","doc":"Naming functions","ref":"Bonny.Naming.html"},{"type":"function","title":"Bonny.Naming.module_to_kind/1","doc":"Converts an elixir module name to a string for use as the CRD's kind . Examples iex&gt; Bonny.Naming . module_to_kind ( Pod ) &quot;Pod&quot; iex&gt; Bonny.Naming . module_to_kind ( Controllers.V1.Pod ) &quot;Pod&quot;","ref":"Bonny.Naming.html#module_to_kind/1"},{"type":"function","title":"Bonny.Naming.module_version/1","doc":"Extract the CRD API version from the module name. Defaults to &quot;v1&quot; Examples iex&gt; Bonny.Naming . module_version ( Pod ) &quot;v1&quot; iex&gt; Bonny.Naming . module_version ( Controllers.V1.Pod ) &quot;v1&quot; iex&gt; Bonny.Naming . module_version ( Controllers.V1Alpha1.Pod ) &quot;v1alpha1&quot;","ref":"Bonny.Naming.html#module_version/1"},{"type":"behaviour","title":"Bonny.Operator","doc":"Defines a Bonny operator. The operator defines custom resources, watch queries and their controllers and serves as the entry point to the watching and handling of processes. Overall, an operator has the following responsibilities: to provide a wrapper for starting and stopping the operator as part of a supervision tree To define the resources to be watched together with the controllers which handle action events on those resources. to define an initial pluggable pipeline for all action events to pass through To define any custom resources ending up in the manifest generated by mix bonny.gen.manifest Operators An operator is defined with the help of Bonyy.Operator . The step :delegate_to_controller has do be part of the pipeline. It is the step that calls the handling controller for a given action event: defmodule MyOperatorApp.Operator do use Bonny.Operator , default_watching_namespace : &quot;default&quot; # step ... step :delegate_to_controller # step ... def controllers ( watching_namespace , _opts ) do [ %{ query : K8s.Client . watch ( &quot;my-controller.io&quot; , &quot;MyCustomResource&quot; , namespace : nil ) controller : MyOperator.Controller.MyCustomResourceController } ] end end","ref":"Bonny.Operator.html"},{"type":"callback","title":"Bonny.Operator.controllers/2","doc":"","ref":"Bonny.Operator.html#c:controllers/2"},{"type":"callback","title":"Bonny.Operator.crds/0","doc":"","ref":"Bonny.Operator.html#c:crds/0"},{"type":"type","title":"Bonny.Operator.controller_spec/0","doc":"","ref":"Bonny.Operator.html#t:controller_spec/0"},{"type":"module","title":"Bonny.Operator.LeaderElector","doc":"The leader uses a Kubernetes Lease to make sure the operator only runs on one single replica (the leader) at the same time. Enabling the Leader Election Functionality still in Beta The leader election is still being tested. Enable it for testing purposes only and please report any issues on Github. To enable leader election you have to pass the enable_leader_election: true option when adding the operator to your Supervisor : defmodule MyOperator.Application do use Application def start ( _type , env : env ) do children = [ { MyOperator.Operator , conn : MyOperator.K8sConn . get! ( env ) , watch_namespace : :all , enable_leader_election : true } # &lt;-- starts the leader elector ] opts = [ strategy : :one_for_one , name : MyOperator.Supervisor ] Supervisor . start_link ( children , opts ) end end","ref":"Bonny.Operator.LeaderElector.html"},{"type":"function","title":"Bonny.Operator.LeaderElector.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Bonny.Operator.LeaderElector.html#child_spec/1"},{"type":"function","title":"Bonny.Operator.LeaderElector.start_link/3","doc":"","ref":"Bonny.Operator.LeaderElector.html#start_link/3"},{"type":"module","title":"Bonny.PeriodicTask","doc":"Register periodically run tasks. Use for running tasks as a part of reconciling a CRD with a lifetime, duration, or interval field. Note: Must be started by your operator. Add Bonny.PeriodicTask.sttart_link(:ok) to your application. Functions are expected to return one of: :ok - task will be passed to subsequent calls {:ok, new_state} state field will be updated in task and provided to next call {:stop, reason} task will be removed from execution loop. Use for tasks opting out of being re-run any() - any other result is treated as an error, and the execution loop will be halted Examples Registering a task iex&gt; Bonny.PeriodicTask . new ( :pod_evictor , { PodEvictor , :evict , [ reconcile_payload_map ] } , 5000 ) Unregistering a task iex&gt; Bonny.PeriodicTask . unregister ( :pod_evictor )","ref":"Bonny.PeriodicTask.html"},{"type":"function","title":"Bonny.PeriodicTask.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Bonny.PeriodicTask.html#child_spec/1"},{"type":"function","title":"Bonny.PeriodicTask.new/3","doc":"Registers and starts a new task given Bonny.PeriodicTask attributes","ref":"Bonny.PeriodicTask.html#new/3"},{"type":"function","title":"Bonny.PeriodicTask.register/1","doc":"Registers and starts a new Bonny.PeriodicTask","ref":"Bonny.PeriodicTask.html#register/1"},{"type":"function","title":"Bonny.PeriodicTask.start_link/1","doc":"","ref":"Bonny.PeriodicTask.html#start_link/1"},{"type":"function","title":"Bonny.PeriodicTask.unregister/1","doc":"Unregisters and stops a Bonny.PeriodicTask","ref":"Bonny.PeriodicTask.html#unregister/1"},{"type":"type","title":"Bonny.PeriodicTask.t/0","doc":"","ref":"Bonny.PeriodicTask.html#t:t/0"},{"type":"module","title":"Bonny.Pluggable.AddManagedByLabelToDescendants","doc":"Adds the app.kubernetes.io/managed-by label to all descendants registered within the pipeline. Add this to your operator or controllers to set this label to a value of your choice. Options :managed_by - Required. The value the label should be set to. Examples step Bonny.Pluggable.AddManagedByLabelToDescendants , managed_by : Bonny.Config . name ( )","ref":"Bonny.Pluggable.AddManagedByLabelToDescendants.html"},{"type":"module","title":"Bonny.Pluggable.AddMissingGVK","doc":"The Kubernetes API sometimes doesn't set the fields apiVersion and kind on items of a list operation. E.g. if you use K8s.Client to get a list of deployments, the deployments won't contains those two fields. This is being discussed on https://github.com/kubernetes/kubernetes/issues/3030 . Bonny sometimes depends on apiVersion and kind to be defined on the resource being handled. This is the case for setting the status, e.g. when using Bonny.Pluggable.SkipObservedGenerations or Bonny.Axn.update_status/2 . Add this step to your controller in order to set those values on all resources being handled. Examples step Bonny.Pluggable.AddMissingGVK , apiVersion : &quot;apps/v1&quot; , kind : &quot;Deployment&quot;","ref":"Bonny.Pluggable.AddMissingGVK.html"},{"type":"module","title":"Bonny.Pluggable.ApplyDescendants","doc":"Applies all the descendants added to the %Bonny.Axn{} struct. Options :events_for_actions - List of actions for which events will be created upon successful apply. Defaults to [:add, :modify] (Reconcile actions are triggered regularly which would create lots of events for no actions.) :force and :field_manager - Options forwarded to K8s.Client.apply() . Examples step Bonny.Pluggable.ApplyDescendants , events_for_actions : [ :add , :modify , :reconcile ] , field_manager : &quot;MyOperator&quot; , force : true","ref":"Bonny.Pluggable.ApplyDescendants.html"},{"type":"module","title":"Bonny.Pluggable.ApplyStatus","doc":"Applies the status of the given %Bonny.Axn{} struct to the status subresource. Options :force and :field_manager - Options forwarded to K8s.Client.apply() . Examples step Bonny.Pluggable.ApplyStatus , field_manager : &quot;MyOperator&quot; , force : true","ref":"Bonny.Pluggable.ApplyStatus.html"},{"type":"module","title":"Bonny.Pluggable.Finalizer","doc":"Declare a finalizer and its implementation. Kubernetes Docs: https://kubernetes.io/docs/concepts/overview/working-with-objects/finalizers/ https://kubernetes.io/blog/2021/05/14/using-finalizers-to-control-deletion/ Use with SkipObservedGenerations This step is best used with and placed right after Bonny.Pluggable.SkipObservedGenerations in your controller. Have a look at the examples below. Note for Testing This step directly updates the resource on the kubernetes cluster. In order to write unit tests, you therefore want to use K8s.Client.DynamicHTTPProvider in order to mock the calls to Kubernetes. Examples See options/0 , finalizer_impl/0 and add_to_resource/0 for more infos on the options. By default, a missing finalizer is not added to the resource. step Bonny.Pluggable.SkipObservedGenerations step Bonny.Pluggable.Finalizer , id : &quot;example.com/cleanup&quot; , impl : &amp; __MODULE__ . cleanup / 1 Set add_to_resource to true in order for Bonny to always add it. step Bonny.Pluggable.SkipObservedGenerations step Bonny.Pluggable.Finalizer , id : &quot;example.com/cleanup&quot; , impl : &amp; __MODULE__ . cleanup / 1 , add_to_resource : true Or make it depending on the event/resource and enable logs. step Bonny.Pluggable.SkipObservedGenerations step Bonny.Pluggable.Finalizer , id : &quot;example.com/cleanup&quot; , impl : &amp; __MODULE__ . cleanup / 1 , add_to_resource : &amp; __MODULE__ . deletion_policy_not_abandon / 1 , log : :debug","ref":"Bonny.Pluggable.Finalizer.html"},{"type":"type","title":"Bonny.Pluggable.Finalizer.add_to_resource/0","doc":"Boolean or callback of arity 1 to tell Bonny whether or not to add the finalizer to the resource if it is missing. If it is a callback, it receives the %Bonny.Axn{} token and shoulr return a boolean .","ref":"Bonny.Pluggable.Finalizer.html#t:add_to_resource/0"},{"type":"type","title":"Bonny.Pluggable.Finalizer.finalizer_impl/0","doc":"The implementation of the finalizer. This is a function of arity 1 which is called when the resource is deleted. It receives the %Bonny.Axn{} token as argument and should return the same.","ref":"Bonny.Pluggable.Finalizer.html#t:finalizer_impl/0"},{"type":"type","title":"Bonny.Pluggable.Finalizer.options/0","doc":"id - Fully qualified finalizer identifier impl - The implementation of the finalizer. See finalizer_impl/0 add_to_resource - (otional) whether Bonny should add the finalizer to the resource if it is missing. See add_to_resource/0 %Bonny.Axn{} token. Defaults to false . log_level - (optional) Log level used for logging by this step. :disable for no logs. Defaults to :disable","ref":"Bonny.Pluggable.Finalizer.html#t:options/0"},{"type":"module","title":"Bonny.Pluggable.Logger","doc":"A pluggable step for logging basic action event information in the format: { &quot;NAMESPACE/OBJECT_NAME&quot; , API_VERSION , &quot;Kind=KIND, Action=ACTION&quot; } Example: { &quot;default/my-object&quot; , &quot;example.com/v1&quot; , &quot;Kind=MyCustomResource, Action=:add&quot; } - Processing event { &quot;default/my-object&quot; , &quot;example.com/v1&quot; , &quot;Kind=MyCustomResource, Action=:add&quot; } - Applying status { &quot;default/my-object&quot; , &quot;example.com/v1&quot; , &quot;Kind=MyCustomResource, Action=:add&quot; } - Emitting Normal event { &quot;default/my-object&quot; , &quot;example.com/v1&quot; , &quot;Kind=MyCustomResource, Action=:add&quot; } - Applying descendant { &quot;default/nginx&quot; , &quot;apps/v1&quot; , &quot;Kind=Deployment&quot; } To use it, just add a step to the desired module. step Bonny.Pluggable.Logger , level : :debug Options :level - The log level at which this plug should log its request info. Default is :info . The list of supported levels is available in the Logger documentation.","ref":"Bonny.Pluggable.Logger.html"},{"type":"function","title":"Bonny.Pluggable.Logger.call/2","doc":"Callback implementation for Pluggable.call/2 .","ref":"Bonny.Pluggable.Logger.html#call/2"},{"type":"function","title":"Bonny.Pluggable.Logger.init/1","doc":"Callback implementation for Pluggable.init/1 .","ref":"Bonny.Pluggable.Logger.html#init/1"},{"type":"module","title":"Bonny.Pluggable.SkipObservedGenerations","doc":"Halts the pipelines for a defined list of actions if the observed generation equals the resource's generation. It also sets the observed generation value before applying the resource status to the cluster. Options :actions - The actions for which this rule applies. Defaults to [:add, :modify] . :observed_generation_key - The resource status key where the observed generation is stored. This will be passed to Kernel.get_in() . Defaults to [&quot;status&quot;, &quot;observedGeneration&quot;] . Usage step Bonny.Pluggable.SkipObservedGenerations , actions : [ :add , :modify , :reconcile ] , observed_generation_key : ~w(status internal observedGeneration)","ref":"Bonny.Pluggable.SkipObservedGenerations.html"},{"type":"module","title":"Bonny.Resource","doc":"Helper functions for dealing with kubernetes resources.","ref":"Bonny.Resource.html"},{"type":"function","title":"Bonny.Resource.add_owner_reference/3","doc":"Add an owner reference to the given resource. Example iex&gt; owner = %{ ...&gt; &quot;apiVersion&quot; =&gt; &quot;example.com/v1&quot; , ...&gt; &quot;kind&quot; =&gt; &quot;Orange&quot; , ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;name&quot; =&gt; &quot;annoying&quot; , ...&gt; &quot;namespace&quot; =&gt; &quot;default&quot; , ...&gt; &quot;uid&quot; =&gt; &quot;e19b6f40-3293-11ed-a261-0242ac120002&quot; ...&gt; } ...&gt; } ...&gt; resource = %{ ...&gt; &quot;apiVersion&quot; =&gt; &quot;v1&quot; , ...&gt; &quot;kind&quot; =&gt; &quot;Pod&quot; , ...&gt; &quot;metadata&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;nginx&quot; , &quot;namespace&quot; =&gt; &quot;default&quot; } ...&gt; # spec ...&gt; } ...&gt; Bonny.Resource . add_owner_reference ( resource , owner ) %{ &quot;apiVersion&quot; =&gt; &quot;v1&quot; , &quot;kind&quot; =&gt; &quot;Pod&quot; , &quot;metadata&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;nginx&quot; , &quot;namespace&quot; =&gt; &quot;default&quot; , &quot;ownerReferences&quot; =&gt; [ %{ &quot;apiVersion&quot; =&gt; &quot;example.com/v1&quot; , &quot;blockOwnerDeletion&quot; =&gt; false , &quot;controller&quot; =&gt; true , &quot;kind&quot; =&gt; &quot;Orange&quot; , &quot;name&quot; =&gt; &quot;annoying&quot; , &quot;uid&quot; =&gt; &quot;e19b6f40-3293-11ed-a261-0242ac120002&quot; } ] } }","ref":"Bonny.Resource.html#add_owner_reference/3"},{"type":"function","title":"Bonny.Resource.apply/3","doc":"Applies the given resource to the cluster.","ref":"Bonny.Resource.html#apply/3"},{"type":"function","title":"Bonny.Resource.apply_async/3","doc":"Applies the given resource to the cluster.","ref":"Bonny.Resource.html#apply_async/3"},{"type":"function","title":"Bonny.Resource.apply_status/3","doc":"Applies the status subresource of the given resource to the cluster. If the given resource doesn't contain a status object, nothing is done and :noop is returned.","ref":"Bonny.Resource.html#apply_status/3"},{"type":"function","title":"Bonny.Resource.drop_managed_fields/1","doc":"Removes .metadata.managedFields from the resource.","ref":"Bonny.Resource.html#drop_managed_fields/1"},{"type":"function","title":"Bonny.Resource.drop_rv/1","doc":"Removes .metadata.resourceVersion from the resource.","ref":"Bonny.Resource.html#drop_rv/1"},{"type":"function","title":"Bonny.Resource.gvkn/1","doc":"Returns a tuple in the form {apiVersion, kind, namespace/name} for namespaced resources {apiVersion, kind, name} for cluster scoped resources","ref":"Bonny.Resource.html#gvkn/1"},{"type":"function","title":"Bonny.Resource.resource_reference/1","doc":"Get a reference to the given resource Example iex&gt; resource = %{ ...&gt; &quot;apiVersion&quot; =&gt; &quot;example.com/v1&quot; , ...&gt; &quot;kind&quot; =&gt; &quot;Orange&quot; , ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;name&quot; =&gt; &quot;annoying&quot; , ...&gt; &quot;namespace&quot; =&gt; &quot;default&quot; , ...&gt; &quot;uid&quot; =&gt; &quot;e19b6f40-3293-11ed-a261-0242ac120002&quot; ...&gt; } ...&gt; } ...&gt; Bonny.Resource . resource_reference ( resource ) %{ &quot;apiVersion&quot; =&gt; &quot;example.com/v1&quot; , &quot;kind&quot; =&gt; &quot;Orange&quot; , &quot;name&quot; =&gt; &quot;annoying&quot; , &quot;namespace&quot; =&gt; &quot;default&quot; , &quot;uid&quot; =&gt; &quot;e19b6f40-3293-11ed-a261-0242ac120002&quot; }","ref":"Bonny.Resource.html#resource_reference/1"},{"type":"function","title":"Bonny.Resource.set_label/3","doc":"Set a label on the given resource. Example iex&gt; resource = %{ ...&gt; &quot;apiVersion&quot; =&gt; &quot;v1&quot; , ...&gt; &quot;kind&quot; =&gt; &quot;Pod&quot; , ...&gt; &quot;metadata&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;nginx&quot; , &quot;namespace&quot; =&gt; &quot;default&quot; } ...&gt; # spec ...&gt; } ...&gt; Bonny.Resource . set_label ( resource , &quot;app.kubernetes.io/managed-by&quot; , &quot;my-operator&quot; ) %{ &quot;apiVersion&quot; =&gt; &quot;v1&quot; , &quot;kind&quot; =&gt; &quot;Pod&quot; , &quot;metadata&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;nginx&quot; , &quot;namespace&quot; =&gt; &quot;default&quot; , &quot;labels&quot; =&gt; %{ &quot;app.kubernetes.io/managed-by&quot; =&gt; &quot;my-operator&quot; } } }","ref":"Bonny.Resource.html#set_label/3"},{"type":"function","title":"Bonny.Resource.set_observed_generation/1","doc":"Sets .status.observedGeneration to .metadata.generation","ref":"Bonny.Resource.html#set_observed_generation/1"},{"type":"type","title":"Bonny.Resource.t/0","doc":"","ref":"Bonny.Resource.html#t:t/0"},{"type":"module","title":"Bonny.Server.AsyncStreamRunner","doc":"Runs the given stream in a separate process. Prepare your stream and add this Runner to your supervision tree in order to control it (e.g. restart after the stream ends). Example # prepare a stream stream = conn |&gt; K8s.Client . stream ( operation ) |&gt; Stream . filter ( &amp; filter_resources / 1 ) |&gt; Stream . map ( &amp; process_stream / 1 ) children = [ { Bonny.Server.AsyncStreamRunner , name : ReconcileServer , stream : stream , termination_delay : 30_000 , ] Supervisor . init ( children , strategy : :one_for_one ) Options :stream - The (prepared) stream to run :name (optional) - Register this process under the given name. :termination_delay (optional) - After the stream ends, how many milliseconds to wait before the process terminates (and might be restarted by the Supervisor). Per default there's no delay","ref":"Bonny.Server.AsyncStreamRunner.html"},{"type":"function","title":"Bonny.Server.AsyncStreamRunner.child_spec/1","doc":"","ref":"Bonny.Server.AsyncStreamRunner.html#child_spec/1"},{"type":"function","title":"Bonny.Server.AsyncStreamRunner.run/2","doc":"","ref":"Bonny.Server.AsyncStreamRunner.html#run/2"},{"type":"function","title":"Bonny.Server.AsyncStreamRunner.start_link/1","doc":"","ref":"Bonny.Server.AsyncStreamRunner.html#start_link/1"},{"type":"behaviour","title":"Bonny.Server.Reconciler","doc":"Creates a stream that, when run, streams a list of resources and calls reconcile/1 on the given controller for each resource in the stream in parallel. Example reconciliation_stream = Bonny.Server.Reconciler . get_stream ( controller ) Task . async ( fn -&gt; Stream . run ( reconciliation_stream ) end )","ref":"Bonny.Server.Reconciler.html"},{"type":"function","title":"Bonny.Server.Reconciler.get_raw_stream/3","doc":"","ref":"Bonny.Server.Reconciler.html#get_raw_stream/3"},{"type":"function","title":"Bonny.Server.Reconciler.get_stream/4","doc":"Prepares a stream wich maps each resoruce returned by the reconcile_operation to a function reconcile/1 on the given module . If given, the stream_opts are passed to K8s.Client.stream/3","ref":"Bonny.Server.Reconciler.html#get_stream/4"},{"type":"callback","title":"Bonny.Server.Reconciler.reconcile/1","doc":"","ref":"Bonny.Server.Reconciler.html#c:reconcile/1"},{"type":"behaviour","title":"Bonny.Server.Scheduler","doc":"Kubernetes custom scheduler interface. Built on top of Reconciler . The only function that needs to be implemented is select_node_for_pod/2 . All others defined by behaviour have default implementations. Examples Will schedule each unschedule pod with spec.schedulerName=cheap-node to a node with a label cheap=true . nodes is a stream that can be lazily filtered: defmodule CheapNodeScheduler do use Bonny.Server.Scheduler , name : &quot;cheap-node&quot; @impl Bonny.Server.Scheduler def select_node_for_pod ( _pod , nodes ) do nodes |&gt; Stream . filter ( fn ( node ) -&gt; is_cheap = K8s.Resource . label ( node , &quot;cheap&quot; ) is_cheap == &quot;true&quot; end ) |&gt; Enum . take ( 1 ) |&gt; List . first end end CheapNodeScheduler . start_link ( ) Will schedule each unschedule pod with spec.schedulerName=random-node to a random node: defmodule RandomNodeScheduler do use Bonny.Server.Scheduler , name : &quot;random-node&quot; @impl Bonny.Server.Scheduler def select_node_for_pod ( _pod , nodes ) do Enum . random ( nodes ) end end RandomNodeScheduler . start_link ( ) Override nodes/0 default implementation ( pods/0 can be overridden too). Schedules pod on a random GPU node: defmodule GpuScheduler do use Bonny.Server.Scheduler , name : &quot;gpu-node&quot; @impl Bonny.Server.Scheduler def select_node_for_pod ( _pod , nodes ) do Enum . random ( nodes ) end @impl Bonny.Server.Scheduler def nodes ( ) do label = &quot;my.label.on.gpu.instances&quot; conn = Bonny.Config . conn ( ) op = K8s.Client . list ( &quot;v1&quot; , :nodes ) K8s.Client . stream ( conn , op , params : %{ labelSelector : label } ) end end GpuScheduler . start_link ( )","ref":"Bonny.Server.Scheduler.html"},{"type":"function","title":"Bonny.Server.Scheduler.bind/3","doc":"Binds a pod to a node","ref":"Bonny.Server.Scheduler.html#bind/3"},{"type":"callback","title":"Bonny.Server.Scheduler.conn/0","doc":"","ref":"Bonny.Server.Scheduler.html#c:conn/0"},{"type":"callback","title":"Bonny.Server.Scheduler.field_selector/0","doc":"Field selector for selecting unscheduled pods waiting to be scheduled by this scheduler. Default implementation is all unscheduled pods assigned to this scheduler.","ref":"Bonny.Server.Scheduler.html#c:field_selector/0"},{"type":"function","title":"Bonny.Server.Scheduler.field_selector/1","doc":"Kubernetes API fieldSelector value for unbound pods waiting on the given scheduler.","ref":"Bonny.Server.Scheduler.html#field_selector/1"},{"type":"callback","title":"Bonny.Server.Scheduler.name/0","doc":"Name of the scheduler.","ref":"Bonny.Server.Scheduler.html#c:name/0"},{"type":"function","title":"Bonny.Server.Scheduler.nodes/1","doc":"Returns a list of all nodes in the cluster.","ref":"Bonny.Server.Scheduler.html#nodes/1"},{"type":"callback","title":"Bonny.Server.Scheduler.nodes/1","doc":"List of nodes available to this scheduler. Default implementation is all nodes in cluster.","ref":"Bonny.Server.Scheduler.html#c:nodes/1"},{"type":"function","title":"Bonny.Server.Scheduler.reconcile/2","doc":"","ref":"Bonny.Server.Scheduler.html#reconcile/2"},{"type":"callback","title":"Bonny.Server.Scheduler.select_node_for_pod/2","doc":"Selects the best node for the current pod . Takes the current unscheduled pod and a Stream of nodes. pod is provided in the event that taints or affinities would need to be respected by the scheduler. Returns the node to schedule on.","ref":"Bonny.Server.Scheduler.html#c:select_node_for_pod/2"},{"type":"module","title":"Bonny.Server.Scheduler.Binding","doc":"Kubernetes binding interface. Currently undocumented in Kubernetes docs. Links Example using curl Example using golang","ref":"Bonny.Server.Scheduler.Binding.html"},{"type":"function","title":"Bonny.Server.Scheduler.Binding.create/3","doc":"Creates the pod's /binding subresource through K8s.","ref":"Bonny.Server.Scheduler.Binding.html#create/3"},{"type":"function","title":"Bonny.Server.Scheduler.Binding.new/2","doc":"Returns a map representing a Binding kubernetes resource Example iex&gt; pod = %{ &quot;metadata&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;nginx&quot; , &quot;namespace&quot; =&gt; &quot;default&quot; } } ...&gt; node = %{ &quot;metadata&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;kewl-node&quot; } } iex&gt; Bonny.Server.Scheduler.Binding . new ( pod , node ) %{ &quot;apiVersion&quot; =&gt; &quot;v1&quot; , &quot;kind&quot; =&gt; &quot;Binding&quot; , &quot;metadata&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;nginx&quot; , &quot;namespace&quot; =&gt; &quot;default&quot; } , &quot;target&quot; =&gt; %{ &quot;apiVersion&quot; =&gt; &quot;v1&quot; , &quot;kind&quot; =&gt; &quot;Node&quot; , &quot;name&quot; =&gt; &quot;kewl-node&quot; } }","ref":"Bonny.Server.Scheduler.Binding.html#new/2"},{"type":"module","title":"Bonny.Server.Watcher","doc":"Creates the stream for watching resources in kubernetes and prepares its processing. Watching a resource in kubernetes results in a stream of add/modify/delete events. This module uses K8s.Client.stream/3 to create such a stream and maps events to a controller's event handler. It is then up to the caller to run the resulting stream. Example watch_stream = Bonny.Server.Watcher . get_stream ( controller ) Task . async ( fn -&gt; Stream . run ( watch_stream ) end )","ref":"Bonny.Server.Watcher.html"},{"type":"function","title":"Bonny.Server.Watcher.get_raw_stream/2","doc":"","ref":"Bonny.Server.Watcher.html#get_raw_stream/2"},{"type":"function","title":"Bonny.Server.Watcher.get_stream/3","doc":"","ref":"Bonny.Server.Watcher.html#get_stream/3"},{"type":"type","title":"Bonny.Server.Watcher.action/0","doc":"","ref":"Bonny.Server.Watcher.html#t:action/0"},{"type":"type","title":"Bonny.Server.Watcher.watch_event/0","doc":"","ref":"Bonny.Server.Watcher.html#t:watch_event/0"},{"type":"module","title":"Bonny.Sys.Event","doc":"Telemetry event definitions for this library","ref":"Bonny.Sys.Event.html"},{"type":"function","title":"Bonny.Sys.Event.events/0","doc":"See Bonny.Sys.Telemetry.events/0 .","ref":"Bonny.Sys.Event.html#events/0"},{"type":"module","title":"Bonny.Sys.Logger","doc":"Attaches telemetry events to the Elixir Logger","ref":"Bonny.Sys.Logger.html"},{"type":"function","title":"Bonny.Sys.Logger.attach/0","doc":"Attaches telemetry events to the Elixir Logger","ref":"Bonny.Sys.Logger.html#attach/0"},{"type":"module","title":"Bonny.Sys.Telemetry","doc":"Telemetry event definitions for this library","ref":"Bonny.Sys.Telemetry.html"},{"type":"function","title":"Bonny.Sys.Telemetry.events/0","doc":"","ref":"Bonny.Sys.Telemetry.html#events/0"},{"type":"module","title":"DeploymentEventLogController","doc":"This is a goofy config, but it makes this work in dev w/o having to POST an Example CRD. This controller simply logs lifecycle events on Deployments.","ref":"DeploymentEventLogController.html"},{"type":"function","title":"DeploymentEventLogController.handle_event/2","doc":"","ref":"DeploymentEventLogController.html#handle_event/2"},{"type":"function","title":"DeploymentEventLogController.rbac_rules/0","doc":"Callback implementation for Bonny.ControllerV2.rbac_rules/0 .","ref":"DeploymentEventLogController.html#rbac_rules/0"},{"type":"function","title":"DeploymentEventLogController.track_event/2","doc":"","ref":"DeploymentEventLogController.html#track_event/2"},{"type":"module","title":"Mix.Bonny","doc":"Mix task helpers","ref":"Mix.Bonny.html"},{"type":"function","title":"Mix.Bonny.add_or_create_with/5","doc":"","ref":"Mix.Bonny.html#add_or_create_with/5"},{"type":"function","title":"Mix.Bonny.app_dir_name/0","doc":"","ref":"Mix.Bonny.html#app_dir_name/0"},{"type":"function","title":"Mix.Bonny.app_name/0","doc":"Get the OTP app name","ref":"Mix.Bonny.html#app_name/0"},{"type":"function","title":"Mix.Bonny.append_or_create_with/4","doc":"Appends append_content to target . If target does not exist, a new file with new_file_content is created.","ref":"Mix.Bonny.html#append_or_create_with/4"},{"type":"function","title":"Mix.Bonny.copy/2","doc":"","ref":"Mix.Bonny.html#copy/2"},{"type":"function","title":"Mix.Bonny.ensure_module_name/1","doc":"Capitalizes the string if it does not begin with a capital letter.","ref":"Mix.Bonny.html#ensure_module_name/1"},{"type":"function","title":"Mix.Bonny.error/1","doc":"","ref":"Mix.Bonny.html#error/1"},{"type":"function","title":"Mix.Bonny.hyphenated_app_name/0","doc":"Get the OTP app name with dashes","ref":"Mix.Bonny.html#hyphenated_app_name/0"},{"type":"function","title":"Mix.Bonny.no_umbrella!/0","doc":"","ref":"Mix.Bonny.html#no_umbrella!/0"},{"type":"function","title":"Mix.Bonny.parse_args/3","doc":"Parse CLI input","ref":"Mix.Bonny.html#parse_args/3"},{"type":"function","title":"Mix.Bonny.prepend_or_create_with/4","doc":"Prepends append_content to target . If target does not exist, a new file with new_file_content is created.","ref":"Mix.Bonny.html#prepend_or_create_with/4"},{"type":"function","title":"Mix.Bonny.render/2","doc":"Render text to a file. Special handling for the path &quot;-&quot; will render to STDOUT","ref":"Mix.Bonny.html#render/2"},{"type":"function","title":"Mix.Bonny.render_template/3","doc":"","ref":"Mix.Bonny.html#render_template/3"},{"type":"function","title":"Mix.Bonny.template/1","doc":"","ref":"Mix.Bonny.html#template/1"},{"type":"task","title":"Mix.Tasks.Bonny.Gen.Controller","doc":"Generates a new CRD controller An operator can have multiple controllers. Each controller handles the lifecycle of a custom resource. mix bonny.gen.controller Open up your controller and add functionality for your resources lifecycle: Add Modify Delete Reconcile If you selected to add a CRD, also edit the generated CRD version module.","ref":"Mix.Tasks.Bonny.Gen.Controller.html"},{"type":"function","title":"Mix.Tasks.Bonny.Gen.Controller.get_input/1","doc":"","ref":"Mix.Tasks.Bonny.Gen.Controller.html#get_input/1"},{"type":"function","title":"Mix.Tasks.Bonny.Gen.Controller.run/1","doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Bonny.Gen.Controller.html#run/1"},{"type":"task","title":"Mix.Tasks.Bonny.Gen.Dockerfile","doc":"Generates a Dockerfile for this operator","ref":"Mix.Tasks.Bonny.Gen.Dockerfile.html"},{"type":"function","title":"Mix.Tasks.Bonny.Gen.Dockerfile.run/1","doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Bonny.Gen.Dockerfile.html#run/1"},{"type":"task","title":"Mix.Tasks.Bonny.Gen.Manifest","doc":"Generates the Kubernetes YAML manifest for this operator mix bonny.gen.manifest expects a docker image name if deploying to a cluster. You may optionally provide a namespace. Examples The image switch is required. Options: --image (docker image to deploy) --namespace (of service account and deployment; defaults to &quot;default&quot;) --out (path to save manifest; defaults to &quot;manifest.yaml&quot;) Deploying to kubernetes: docker build -t $(YOUR_IMAGE_URL) . docker push $(YOUR_IMAGE_URL) mix bonny.gen.manifest --image $(YOUR_IMAGE_URL):latest --namespace default kubectl apply -f manifest.yaml -n default To skip the deployment for running an operator outside of the cluster (like in development) simply omit the --image flag: mix bonny.gen.manifest","ref":"Mix.Tasks.Bonny.Gen.Manifest.html"},{"type":"function","title":"Mix.Tasks.Bonny.Gen.Manifest.run/1","doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Bonny.Gen.Manifest.html#run/1"},{"type":"task","title":"Mix.Tasks.Bonny.Init","doc":"Initialized an operator wiht bonny. Initializes application configuration Generates helper files for tests","ref":"Mix.Tasks.Bonny.Init.html"},{"type":"function","title":"Mix.Tasks.Bonny.Init.get_input/1","doc":"","ref":"Mix.Tasks.Bonny.Init.html#get_input/1"},{"type":"function","title":"Mix.Tasks.Bonny.Init.run/1","doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Bonny.Init.html#run/1"},{"type":"module","title":"TestScheduler","doc":"","ref":"TestScheduler.html"},{"type":"function","title":"TestScheduler.child_spec/1","doc":"","ref":"TestScheduler.html#child_spec/1"},{"type":"function","title":"TestScheduler.conn/0","doc":"Callback implementation for Bonny.Server.Scheduler.conn/0 .","ref":"TestScheduler.html#conn/0"},{"type":"function","title":"TestScheduler.field_selector/0","doc":"Kubernetes HTTP API fieldSelector .","ref":"TestScheduler.html#field_selector/0"},{"type":"function","title":"TestScheduler.name/0","doc":"Scheduler name","ref":"TestScheduler.html#name/0"},{"type":"function","title":"TestScheduler.nodes/1","doc":"List of nodes available to this scheduler.","ref":"TestScheduler.html#nodes/1"},{"type":"function","title":"TestScheduler.select_node_for_pod/2","doc":"Callback implementation for Bonny.Server.Scheduler.select_node_for_pod/2 .","ref":"TestScheduler.html#select_node_for_pod/2"},{"type":"exception","title":"Bonny.Axn.DescendantsAlreadyAppliedError","doc":"Error raised when trying to register a descendant or apply the descendants when already applied.","ref":"Bonny.Axn.DescendantsAlreadyAppliedError.html"},{"type":"exception","title":"Bonny.Axn.EventsAlreadyEmittedError","doc":"Error raised when trying to register an event or emit evnts when already emitted.","ref":"Bonny.Axn.EventsAlreadyEmittedError.html"},{"type":"exception","title":"Bonny.Axn.StatusAlreadyAppliedError","doc":"Error raised when trying to update or apply an already applied status","ref":"Bonny.Axn.StatusAlreadyAppliedError.html"},{"type":"extras","title":"README","doc":"Bonny: Kubernetes Development Framework Extend the Kubernetes API with Elixir. Bonny make it easy to create Kubernetes Operators, Controllers, and Custom Schedulers . If Kubernetes CRDs and controllers are new to you, read up on the terminology .","ref":"readme.html"},{"type":"extras","title":"README - Getting Started","doc":"Kickstarting your first controller with bonny is very straight-forward. Bonny comes with some handy mix tasks to help you. mix new your_operator Now add bonny to your dependencies in mix.exs def deps do [ { :bonny , &quot;~&gt; 1.0&quot; } ] end Install dependencies and initialize bonny. This task will ask you to answer a few questions about your operator. Refer to the kubernetes docs for API group and API version. mix deps . get mix bonny . init Don't forget to add the generated operator module to your application supervisor. Configuration mix bonny.init creates a configuration file config/bonny.exs and imports it to config/config.exs for you. Configuring Bonny Configuring bonny is necessary for the manifest generation through mix bonny.gen.manifest . config :bonny , # Function to call to get a K8s.Conn object. # The function should return a %K8s.Conn{} struct or a {:ok, %K8s.Conn{}} tuple get_conn : { K8s.Conn , :from_file , [ &quot;~/.kube/config&quot; , [ context : &quot;docker-for-desktop&quot; ] ] } , # Set the Kubernetes API group for this operator. # This can be overwritten using the @group attribute of a controller group : &quot;your-operator.example.com&quot; , # Name must only consist of only lowercase letters and hyphens. # Defaults to hyphenated mix app name operator_name : &quot;your-operator&quot; , # Name must only consist of only lowercase letters and hyphens. # Defaults to hyphenated mix app name service_account_name : &quot;your-operator&quot; , # Labels to apply to the operator&#39;s resources. labels : %{ &quot;kewl&quot; : &quot;true&quot; } , # Operator deployment resources. These are the defaults. resources : %{ limits : %{ cpu : &quot;200m&quot; , memory : &quot;200Mi&quot; } , requests : %{ cpu : &quot;200m&quot; , memory : &quot;200Mi&quot; } }","ref":"readme.html#getting-started"},{"type":"extras","title":"README - Running outside of a cluster","doc":"Running an operator outside of Kubernetes is not recommended for production use, but can be very useful when testing. To start your operator and connect it to an existing cluster, one must first: Have configured your operator. The above example is a good place to start. Have some way of connecting to your cluster. The most common is to connect using your kubeconfig as in the example: # config.exs config :bonny , get_conn : { K8s.Conn , :from_file , [ &quot;~/.kube/config&quot; , [ context : &quot;optional-alternate-context&quot; ] ] } If you've used mix bonny.init to generate your config, it created a YourOperator.Conn module for you. You can edit that instead. If RBAC is enabled, you must have permissions for creating and modifying CustomResourceDefinition , ClusterRole , ClusterRoleBinding and ServiceAccount . Generate a manifest mix bonny.gen.manifest and install it using kubectl kubectl apply -f manifest.yaml Now you are ready to run your operator iex -S mix","ref":"readme.html#running-outside-of-a-cluster"},{"type":"extras","title":"README - Guides","doc":"Have a look at the guides that come with this repository. Some can even be opened as a livebook. Mix Tasks The Operator Controllers Testing Controllers CRD Versions Migrations Contributing","ref":"readme.html#guides"},{"type":"extras","title":"README - Talks","doc":"Commandeering Kubernetes @ The Big Elixir 2019 slides source code video","ref":"readme.html#talks"},{"type":"extras","title":"README - Example Operators built with this version of Bonny","doc":"Kompost - Providing self-service management of resources for devs","ref":"readme.html#example-operators-built-with-this-version-of-bonny"},{"type":"extras","title":"README - Example Operators built with an older version of Bonny","doc":"Eviction Operator - Bonny v 0.4 Hello Operator - Bonny v 0.4 Todo Operator - Bonny v 0.4","ref":"readme.html#example-operators-built-with-an-older-version-of-bonny"},{"type":"extras","title":"README - Telemetry","doc":"Bonny uses the telemetry to emit event metrics. Events: Bonny.Sys.Telemetry.events() [ [ :reconciler , :reconcile , :start ] , [ :reconciler , :reconcile , :stop ] , [ :reconciler , :reconcile , :exception ] , [ :watcher , :watch , :start ] , [ :watcher , :watch , :stop ] , [ :watcher , :watch , :exception ] , [ :scheduler , :binding , :start ] , [ :scheduler , :binding , :stop ] , [ :scheduler , :binding , :exception ] , [ :task , :execution , :start ] , [ :task , :execution , :stop ] , [ :task , :execution , :exception ] , ]","ref":"readme.html#telemetry"},{"type":"extras","title":"README - Terminology","doc":"Custom Resource : A custom resource is an extension of the Kubernetes API that is not necessarily available on every Kubernetes cluster. In other words, it represents a customization of a particular Kubernetes installation. CRD Custom Resource Definition : The CustomResourceDefinition API resource allows you to define custom resources. Defining a CRD object creates a new custom resource with a name and schema that you specify. The Kubernetes API serves and handles the storage of your custom resource. Controller : A custom controller is a controller that users can deploy and update on a running cluster, independently of the cluster’s own lifecycle. Custom controllers can work with any kind of resource, but they are especially effective when combined with custom resources. The Operator pattern is one example of such a combination. It allows developers to encode domain knowledge for specific applications into an extension of the Kubernetes API. Operator : A set of application specific controllers deployed on Kubernetes and managed via kubectl and the Kubernetes API.","ref":"readme.html#terminology"},{"type":"extras","title":"README - Contributing","doc":"I'm thankful for any contribution to this project. Check out the contribution guide","ref":"readme.html#contributing"},{"type":"extras","title":"README - Operator Blog Posts","doc":"Why Kubernetes Operators are a game changer","ref":"readme.html#operator-blog-posts"},{"type":"extras","title":"Changelog","doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html"},{"type":"extras","title":"Changelog - Unreleased","doc":"","ref":"changelog.html#unreleased"},{"type":"extras","title":"Changelog - [1.2.0] - 2023-06-13","doc":"","ref":"changelog.html#1-2-0-2023-06-13"},{"type":"extras","title":"Changelog - Changed","doc":"Start leader election by default - #195","ref":"changelog.html#changed"},{"type":"extras","title":"Changelog - Fixed","doc":"mix bonny.gen.manifest - Merge RBAC rules for the same resources - #213 Compile time dependency at runtime - #212","ref":"changelog.html#fixed"},{"type":"extras","title":"Changelog - [1.1.3] - 2023-04-09","doc":"Leader Election: Add missing RBAC permission to access leases - #207","ref":"changelog.html#1-1-3-2023-04-09"},{"type":"extras","title":"Changelog - [1.1.2] - 2023-03-07","doc":"Added Simple leader election for running multiple replicas (BETA) - #195 Fixes Fix for an issue reported in #180 already: Add operator name as env variable to deployment. Chores Upgrade k8s to 2.1.1","ref":"changelog.html#1-1-2-2023-03-07"},{"type":"extras","title":"Changelog - [1.1.1] - 2023-02-24","doc":"Fixed Bonny.Pluggable.Finalizer - Remove finalizers from resource if they need to be removed. Bonny.Axn - Regression where descendants were not applied - #192 , #191","ref":"changelog.html#1-1-1-2023-02-24"},{"type":"extras","title":"Changelog - [1.1.0] - 2023-02-22","doc":"This release updates its dependency on k8s to a new major version ( 2.x ). If you're using k8s directly in your code, you should have added it explicitely to your dependencies in mix.exs and this update will fail until you update that dependency manually. If you're using k8s directly in your code but you haven't added it explicetly to your list of dependencies, you might get surprises as 2.x comes with (yet few) breaking changes. Fixed Prevent duplicate descendants Changed Upgraded k8s dependency to 2.x. #173 Added Bonny.Pluggable.AddMissingGVK - A pluggable step for adding missing GVK information to resources - #184 , #183 Helpers to define conditions on custom resources. #188 Bonny.API.Version.add_conditions/1 - Helper to define a schema for conditions on the CRD Bonny.Axn.set_condition/4 - Helper to set a condition on a resource Bonny.Pluggable.Finalizer - A pluggable step to define and implement finalizers, #6 , #189 Bonny.Axn.register_after_processed/2 - Registers a callback to be invoked at the very end of an action event's processing by the operator","ref":"changelog.html#1-1-0-2023-02-22"},{"type":"extras","title":"Changelog - [1.0.1] - 2023-02-04","doc":"Fixed Initialized application calls the wrong function to initialize conn - #181 Don't add operator to supervision tree in :test env per default - #182","ref":"changelog.html#1-0-1-2023-02-04"},{"type":"extras","title":"Changelog - [1.0.0] - 2022-11-28","doc":"With Version 1.0.0, Bonny got a thorough refactoring. Besides this changelog, you might consider the several guides (e.g. the migration guide ) Bonny.Operator was introduced as an entry point to the watching and handling of processes. Your controllers are not more added to the supervision tree by bonny. Instead you must create an operator and add that to your application's supervision tree. The Pluggable (think Plug ) library is used with Bonny.Axn as token to process ADDED , MODIFIED , DELETED and reconciliation events by Pluggable pipelines. Bonny.ControllerV2 was introduced as a successor to Bonny.Controller . It leverages Pluggable.StepBuilder (think Plug.Builder ) to build a pluggable pipeline. Bonny.Event and Bonny.EventRecorder were introducd for Kubernetes event creation ( #156 , #5 ) Why this refactoring? Allows for better CRD and API version definitions With a Pluggable architecture, controllers are much easier to test (Think of Plug.Conn tests) The Pluggable architecture makes your processing pipelines composable and simpler to customize/extend Decoupling of manifest generation and action event processing Internally, the amount of macros was reduced which makes Bonny easier to understand and maintain","ref":"changelog.html#1-0-0-2022-11-28"},{"type":"extras","title":"Changelog - [1.0.0-rc.3] - 2022-11-19","doc":"Fixed Bonny.Mix.Operator - fix manifest generation: remove version from apiGroup in ClusterRole.","ref":"changelog.html#1-0-0-rc-3-2022-11-19"},{"type":"extras","title":"Changelog - [1.0.0-rc.2] - 2022-11-15","doc":"Added Bonny.Pluggable.AddManagedByLabelToDescendants - Adds the app.kubernetes.io/managed-by label to all descendants registered within the pipeline. Allow nil and {controller :: module(), init_opts :: keyword()} in the operator's controllers/2 callback. Fixed K8sConn - Implement spec correctly. Changed Bonny.Axn.apply_descendants/N , Bonny.Axn.apply_status/N - Raise upon error.","ref":"changelog.html#1-0-0-rc-2-2022-11-15"},{"type":"extras","title":"Changelog - [1.0.0-rc.1] - 2022-10-31","doc":"Added Better logs in case of errors while applying status, descendants or events Integration tests for these logs","ref":"changelog.html#1-0-0-rc-1-2022-10-31"},{"type":"extras","title":"Changelog - [1.0.0-rc.0] - 2022-10-29","doc":"Changed With Version 1.0.0, Bonny got a thorough refactoring. Besides this changelog, you might consider the several guides (e.g. the migration guide ) Bonny.Operator was introduced as an entry point to the watching and handling of processes. Your controllers are not more added to the supervision tree by bonny. Instead you must create an operator and add that to your application's supervision tree. The Pluggable (think Plug ) library is used with Bonny.Axn as token to process ADDED , MODIFIED , DELETED and reconciliation events by Pluggable pipelines. Bonny.ControllerV2 was introduced as a successor to Bonny.Controller . It leverages Pluggable.StepBuilder (think Plug.Builder ) to build a pluggable pipeline. Bonny.Event and Bonny.EventRecorder were introducd for Kubernetes event creation ( #156 , #5 ) Why this refactoring? Allows for better CRD and API version definitions With a Pluggable architecture, controllers are much easier to test (Think of Plug.Conn tests) The Pluggable architecture makes your processing pipelines composable and simpler to customize/extend Manifest generation and event processing were decoupled Internally, the amount of macros was reduced which makes Bonny easier to maintain Added Bonny.Pluggable.SkipObservedGenerations - halts the pipelines for a defined list of actions if the observed generation equals the resource's generation. Bonny.Pluggable.ApplyDescendants - applies all the descendants added to the %Bonny.Axn{} struct. Bonny.Pluggable.ApplyStatus - applies the status of the given %Bonny.Axn{} struct to the status subresource. Bonny.Pluggable.Logger - logs an action event and when status, descendants and events are applied to the cluster. If desired, it makes sense to be placed as first step in your operator pipeline but can also be added to a controller pipeline. Bonny.Resource.add_owner_reference/3 used to add the owner reference to resources created by the controller. ( #147 ) An integration test suite was added that runs tests against a &quot;real&quot; kubernetes cluster on the CI pipeline ( #146 , #84 ) Mix task for initializing a new operator mix bonny.init ( #160 , #67 ) Deprecated Bonny.Controller was deprecated in favor of the new design with Bonny.Operator and Bonny.ControllerV2","ref":"changelog.html#1-0-0-rc-0-2022-10-29"},{"type":"extras","title":"Changelog - [0.5.2] - 2022-08-31","doc":"Updated Use name of application in Deployments instead of service account name. ( #142 ) Fixed CRD manifest generation for apiextensions.k8s.io/v1 ( #143 , #117 , #101 )","ref":"changelog.html#0-5-2-2022-08-31"},{"type":"extras","title":"Changelog - [0.5.1] - 2022-05-25","doc":"Fixed Add missing priv folder to package","ref":"changelog.html#0-5-1-2022-05-25"},{"type":"extras","title":"Changelog - [0.5.0] - 2022-04-23","doc":"Version 0.5.0 comes with some major changes. Please read through the migration guide before upgrading.","ref":"changelog.html#0-5-0-2022-04-23"},{"type":"extras","title":"Changelog - Added","doc":"Bonny.Server.AsyncStreamRunner to run streams in a separate process Bonny.Sys.Telemetry defines telemetry spans and events","ref":"changelog.html#added"},{"type":"extras","title":"Changelog - Updated","doc":"Bonny.Server.Watcher and Bonny.Server.Reconciler were rewritten completely. They now prepare streams which are to be run with Bonny.Server.AsyncStreamRunner Dependency k8s was updated to version ~&gt; 1.1 and code was refactored accordingly","ref":"changelog.html#updated"},{"type":"extras","title":"Changelog - Deprecated","doc":"Bonny.Sys.Event was deprecated in favor of Bonny.Sys.Telemetry","ref":"changelog.html#deprecated"},{"type":"extras","title":"Changelog - [0.4.4] - 2021-08-09","doc":"Added @impl to macros for clean compilation error handling for mid-stream errors","ref":"changelog.html#0-4-4-2021-08-09"},{"type":"extras","title":"Changelog - [0.4.3] - 2020-06-09","doc":"Added Configure watched namespace via config.exs or BONNY_POD_NAMESPACE BONNY_POD_NAMESPACE supports &quot;magic&quot; value &quot; ALL &quot;","ref":"changelog.html#0-4-3-2020-06-09"},{"type":"extras","title":"Changelog - [0.4.1] - 2019-11-26","doc":"Added Support for reconciling/watching core resources","ref":"changelog.html#0-4-1-2019-11-26"},{"type":"extras","title":"Changelog - [0.4.0] - 2019-10-23","doc":"Added Basic integration w/ Notion for telemetry Bonny.Server.Reconciler continually process a list operation Bonny.Server.Scheduler write custom kubernetes schedulers Added Bonny.PeriodicTask for scheduling periodically executed functions Changed Dockerfile gen uses OTP releases Removed Removed reconcile_batch_size","ref":"changelog.html#0-4-0-2019-10-23"},{"type":"extras","title":"Changelog - [0.3.3] - 2019-06-25","doc":"Added Add additional printer columns Bonny.Naming module .credo.exs","ref":"changelog.html#0-3-3-2019-06-25"},{"type":"extras","title":"Changelog - [0.3.2] - 2019-04-15","doc":"Added Bonny.Watcher and Bonny.Reconciler telemetry events","ref":"changelog.html#0-3-2-2019-04-15"},{"type":"extras","title":"Changelog - [0.3.1] - 2019-04-11","doc":"Added Support for a reconcile/1 callback reconcile_every config option to schedule how often to run reconciliation reconcile_batch_size to set the size of the HTTP GET limit when fetching batches of items to reconcile Added {:error, binary} as a return value of Controller lifecycle methods Implemented :telemetry library Bonny.Sys.Event.events/0 exposes list of telemetry events mix bonny.gen.manifest --local for building manifests w/o a Deployment for local testing cluster_name: :default config options. Now uses k8s cluster registration configuration. Changed Async watcher event dispatch Replaced HTTPoison with k8s Fixed Receiving :DOWN messages no longer crashes Watcher #20 Issue with partially received events #43 Fix invalid singular name generation from module names &quot;MyMod&quot; -&gt; my_mod; &quot;MyMod&quot; -&gt; mymod Removed Renamed group_version -&gt; api_version Renamed Bonny.CRD.plural/1 -&gt; Bonny.CRD.kind/1 Bypass from test suite Impl.parse_metadata/1 kubeconf_file and kubeconf_opts config options","ref":"changelog.html#0-3-1-2019-04-11"},{"type":"extras","title":"Changelog - [0.3.0] - 2019-03-04","doc":"Changed Replaced k8s_conf library with k8s .","ref":"changelog.html#0-3-0-2019-03-04"},{"type":"extras","title":"Changelog - [0.2.3] - 2019-01-13","doc":"Added Initial public release. Controller lifecycle implementation. CRD Watcher. mix task: controller generator mix task: dockerfile generator mix task: k8s manifest generator","ref":"changelog.html#0-2-3-2019-01-13"},{"type":"extras","title":"Controllers","doc":"Mix . install ( [ :kino , :bonny ] ) Application . put_env ( :bonny , :operator_name , &quot;livebook&quot; )","ref":"controllers.html"},{"type":"extras","title":"Controllers - Creating your first Controller","doc":"When running mix bonny.init , the task asks you to define CRDs and controllers already. It is optional but I advise to do so as it initializes your operator then. To create additional controllers, run mix bonny.gen.controller . mix bonny.gen.controller does not register the controller with your operator. (Note however, that mix bonny.init does!) In order for your controller to do something, you need to add an entry to the controllers/2 callback in your operator. See the operators guide for more information about operators.","ref":"controllers.html#creating-your-first-controller"},{"type":"extras","title":"Controllers - Action Event Handlers","doc":"A controller is a Pluggable step and uses Pluggable.StepBuilder underneath. When an action event is dispatched, the controller is called and all its steps are executed.Your task is to add steps to the controller which process the action event. If you used mix bonny.gen.controller to create the controller, a handle_event/2 step and its implementation are added to your controller by the script. Besides that, mix bonny.gen.controller also adds steps for skipping observed generations. See the section about skipping observed generations for more information on those. defmodule AppleController do use Bonny.ControllerV2 step :handle_event # apply the resource def handle_event ( % Bonny.Axn { action : action } = axn , _opts ) when action in [ :add , :modify , :reconcile ] do IO . inspect ( axn . resource ) success_event ( axn ) end # delete the resource def handle_event ( % Bonny.Axn { action : :delete } = axn , _opts ) do IO . inspect ( axn . resource ) axn end end The step s you implement are called with a %Bonny.Axn{} token. It contains the action which triggered this event, the resource the event regards and other fields. Use pattern matching or a adispatch mechanism to handle the four different action types: add/1 - resource was created in the cluster. delete/1 - resource was deleted from the cluster. modify/1 - resource was modified in the cluster. reconcile/1 - Called on a regular basis in case we missed an action or to fix diverged state. Your event handlers should return the struct it received as first parameter. However, your controller can use helper functions from the Bonny.Axn module to modify it before returning it.","ref":"controllers.html#action-event-handlers"},{"type":"extras","title":"Controllers - Descendant Resources","doc":"Your controller might create descendant resources for its custom resource. For example, a MyAppController would create deployments and services for a MyApp resource. Use Bonny.Axn.register_descendant/3 to add such descendants. Descendants are not directly applied to the cluster. They are only registered within the %Bonny.Axn{} token. Note that you need to add step Bonny.Pluggable.ApplyDescendants to either your controller or operator in order to apply descendants to the cluster. Owner Reference If your controller creates descendant resources for your custom resource, it is good practice to reference the owner(s). In kubernetes, you do this by adding an entry to .metadata.ownerReferences . Bonny.Axn.register_descendant/3 does that for you unless you pass ommit_owner_ref: true as option. defmodule MyAppController do use Bonny.ControllerV2 step :handle_event # apply the resource def handle_event ( % Bonny.Axn { action : action } = axn , _opts ) when action in [ :add , :modify , :reconcile ] do depl = %{ &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot; , &quot;kind&quot; =&gt; &quot;Deployment&quot; , &quot;metadata&quot; =&gt; %{ &quot;namespace&quot; =&gt; &quot;default&quot; , &quot;name&quot; =&gt; axn . resource [ &quot;metadata&quot; ] [ &quot;name&quot; ] } # spec } svc = %{ &quot;apiVersion&quot; =&gt; &quot;v1&quot; , &quot;kind&quot; =&gt; &quot;Service&quot; , &quot;metadata&quot; =&gt; %{ &quot;namespace&quot; =&gt; &quot;default&quot; , &quot;name&quot; =&gt; axn . resource [ &quot;metadata&quot; ] [ &quot;name&quot; ] } # spec } axn |&gt; Bonny.Axn . register_descendant ( depl ) |&gt; Bonny.Axn . register_descendant ( svc ) |&gt; success_event ( ) end # delete the resource def handle_event ( % Bonny.Axn { action : :delete } = axn , _opts ) do # nothing to do because of owner reference success_event ( axn ) end end Let's see the result of the above event handler: Bonny.Axn . new! ( action : :add , conn : nil , resource : %{ &quot;apiVersion&quot; =&gt; &quot;example.com/v1&quot; , &quot;kind&quot; =&gt; &quot;MyApp&quot; , &quot;metadata&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;foo&quot; , &quot;namespace&quot; =&gt; &quot;default&quot; , &quot;uid&quot; =&gt; &quot;e19b6f40-3293-11ed-a261-0242ac120002&quot; } } ) |&gt; MyAppController . call ( [ ] ) |&gt; Map . get ( :descendants )","ref":"controllers.html#descendant-resources"},{"type":"extras","title":"Controllers - The Status Subresource","doc":"Controllers should use a resource's status subresource to communicate back data to the client. This can be results from underlaying APIs or stats. In your handler, use Bonny.Axn.update_status/2 to update the status. Make sure the status subresource is represented in your CRD's schema. defmodule StatusController do use Bonny.ControllerV2 step :handle_event def handle_event ( axn , _ ) do axn |&gt; Bonny.Axn . update_status ( fn status -&gt; put_in ( status , [ Access . key ( :some , %{ } ) , :field ] , &quot;foo&quot; ) end ) |&gt; Bonny.Axn . success_event ( ) end end resource = %{ &quot;apiVersion&quot; =&gt; &quot;example.com/v1&quot; , &quot;kind&quot; =&gt; &quot;MyApp&quot; , &quot;metadata&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;foo&quot; , &quot;namespace&quot; =&gt; &quot;default&quot; , &quot;uid&quot; =&gt; &quot;e19b6f40-3293-11ed-a261-0242ac120002&quot; } } Bonny.Axn . new! ( action : :add , conn : nil , resource : resource ) |&gt; StatusController . call ( [ ] ) |&gt; Map . get ( :status )","ref":"controllers.html#the-status-subresource"},{"type":"extras","title":"Controllers - Skipping Observed Generations","doc":"One of the kubernetes operator best practices is observing generations. This blog post explains it really well . It is extremly useful especially when you work with status subresources to not get another modify event for updating the status. Bonny skips observed generations if you add the Bonny.Pluggable.SkipObservedGenrations step to your controller. Preparations In order to use the Bonny.Pluggable.SkipObservedGenrations step on a custom resource, you have to enable the status subresource and define the correct openAPIV3 schema in your CRD version file : defmodule MyOperator.API.V1.CronTab do use Bonny.API.Version @impl Bonny.API.Version def manifest ( ) do defaults ( ) |&gt; add_observed_generation_status ( ) end end MyOperator.API.V1.CronTab . manifest ( ) How it works Bonny.Pluggable.SkipObservedGenrations compares the current resource's fields .metadata.generation with the field defined by the :observed_generation_key option ( .status.observedGeneration by default). It halts the pipeline if the two values match, i.e. if the resource generation had already been observed. You can define for which actions this rule applies by adding the option :actions when placing the step. By default this rule applies to [:add, :modify] actions. Finally, before the resource status is applied, the module copies the value in .metadata.generation to the field defined by the :observed_generation_key option ( .status.observedGeneration by default). Example This example shows how only :reconcile and :delete events are handled by the controller: defmodule MyThirdResourceController do use Bonny.ControllerV2 step Bonny.Pluggable.SkipObservedGenerations , #  default actions : [ :add , :modify ] , #  default observed_generation_key : [ &quot;status&quot; , &quot;observedGeneration&quot; ] step :handle_event def handle_event ( axn , _ ) do IO . puts ( &quot;handling \#{ axn . action } event.&quot; ) axn end end action = Kino.Input . select ( &quot;Test Events&quot; , add : &quot;add&quot; , modify : &quot;modify&quot; , reconcile : &quot;reconcile&quot; , delete : &quot;delete&quot; ) resource = %{ &quot;apiVersion&quot; =&gt; &quot;example.com/v1&quot; , &quot;kind&quot; =&gt; &quot;MyApp&quot; , &quot;metadata&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;foo&quot; , &quot;namespace&quot; =&gt; &quot;default&quot; , &quot;uid&quot; =&gt; &quot;e19b6f40-3293-11ed-a261-0242ac120002&quot; , &quot;generation&quot; =&gt; 1 } , &quot;status&quot; =&gt; %{ &quot;observedGeneration&quot; =&gt; 1 } } axn = Bonny.Axn . new! ( action : Kino.Input . read ( action ) , conn : nil , resource : resource ) MyThirdResourceController . call ( axn , [ ] ) :ok","ref":"controllers.html#skipping-observed-generations"},{"type":"extras","title":"Controllers - Conditions","doc":"Conditions provide a way to communicate the resource's status in a machine readable state. One use case for conditions are custom health checks in ArgoCD . If you define conditions on your resources, users of your operator can - when using ArgoCD - define a custom health check which changes the status of resources to. degraded if specified conditions fail. Preparations In order to use conditions on custom resources, they have to be initialized in your CRD manifest : defmodule MyOperator.API.V1.CronTab2 do use Bonny.API.Version @impl Bonny.API.Version def manifest ( ) do defaults ( ) |&gt; add_conditions ( ) end end MyOperator.API.V1.CronTab2 . manifest ( ) Usage I find the most elegant usage of conditions is in combination with a with statement. In the following code example, let's assume the controller needs to lookup a secret and a configmap in order to finally create a descendant resource: defmodule MyFourthResourceController do use Bonny.ControllerV2 step :handle_event def handle_event ( axn , _ ) when axn . action in [ :add , :modify , :reconcile ] do with { :secret , { :ok , secret } } &lt;- { :secret , get_secret ( axn . resource ) } , axn &lt;- set_condition ( axn , &quot;Secret&quot; , true , &quot;the secret was loaded successfully.&quot; ) , { :configmap , axn , { :ok , cm } } &lt;- { :configmap , axn , get_configmap ( axn . resource ) } , axn &lt;- set_condition ( axn , &quot;Configmap&quot; , true , &quot;the configmap was loaded successfully.&quot; ) , { :descendant , axn , :ok } &lt;- { :descendant , axn , create_descendant ( axn . resource , secret , cm ) } do axn |&gt; success_event ( ) |&gt; set_condition ( &quot;Descendant&quot; , true , &quot;Descendant was created successfully&quot; ) else { :secret , { :error , error } } -&gt; axn |&gt; failure_event ( message : error ) |&gt; set_condition ( &quot;Secret&quot; , false , error ) { :configmap , axn , { :error , error } } -&gt; axn |&gt; failure_event ( message : error ) |&gt; set_condition ( &quot;Configmap&quot; , false , error ) { :descendant , axn , { :error , error } } -&gt; axn |&gt; failure_event ( message : error ) |&gt; set_condition ( &quot;Descendant&quot; , false , error ) end end # dummy functions: def get_secret ( _ ) , do : { :ok , :secret } def get_configmap ( _ ) , do : { :ok , :configmap } def create_descendant ( _ , :secret , :configmap ) , do : { :error , &quot;Something went wrong&quot; } end Bonny.Axn . new! ( action : :add , conn : nil , resource : %{ } ) |&gt; MyFourthResourceController . call ( [ ] ) |&gt; Map . get ( :status )","ref":"controllers.html#conditions"},{"type":"extras","title":"Controllers - Kubernetes Events","doc":"Kubernetes events provide a way to report back to the client. A Kubernetes event always references the object to which the event relates. For a controller the regarding object would be the handled resource. The user can then use kubectl describe on the custom resource to see the events. Use Bonny.Axn.success_event/2 , Bonny.Axn.failure_event/2 or Bonny.Axn.register_event/6 do register events in the %Bonny.Axn{} struct. Events are going to be applied to the cluster at the end of the Operator pipeline. There is no need to register a step for that. defmodule MyResourceController do use Bonny.ControllerV2 step :handle_event def handle_event ( axn , _ ) when axn . action == :add do Bonny.Axn . success_event ( axn ) end def handle_event ( axn , _ ) when axn . action == :modify do Bonny.Axn . failure_event ( axn ) end end action = Kino.Input . select ( &quot;Test Events&quot; , add : &quot;Success&quot; , modify : &quot;Failure&quot; ) resource = %{ &quot;apiVersion&quot; =&gt; &quot;example.com/v1&quot; , &quot;kind&quot; =&gt; &quot;MyApp&quot; , &quot;metadata&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;foo&quot; , &quot;namespace&quot; =&gt; &quot;default&quot; , &quot;uid&quot; =&gt; &quot;e19b6f40-3293-11ed-a261-0242ac120002&quot; } } action = Kino.Input . read ( action ) axn = Bonny.Axn . new! ( action : action , conn : nil , resource : resource ) MyResourceController . call ( axn , [ ] ) |&gt; Map . get ( :events )","ref":"controllers.html#kubernetes-events"},{"type":"extras","title":"Controllers - RBAC Rules","doc":"Your controller might need special permissions on the kubernetes cluster. Maybe it needs to be able to read secrets. Or it has to be able to create pods. These permissions need to be reflected in the final manifest generated by mix bonny.gen.manifest through RBAC rules. You can define such rules one by defining the rbac_rules/0 callback. This callback should return a list of rbac rules of the following spec: @type rbac_rule :: %{ apiGroups : list ( binary ( ) ) , resources : list ( binary ( ) ) , binary ( ) s : list ( binary ( ) ) } You can use the helper function to_rbac_rule/1 to convert a tuple to an rbac rule. Its spec is: @spec to_rbac_rule ( { binary ( ) | list ( binary ( ) ) , binary ( ) | list ( binary ( ) ) , binary ( ) | list ( binary ( ) ) } ) :: rbac_rule defmodule MySecondResourceController do use Bonny.ControllerV2 @impl Bonny.ControllerV2 def rbac_rules ( ) do [ to_rbac_rule ( { &quot;apps/v1&quot; , &quot;Deployment&quot; , [ &quot;get&quot; , &quot;list&quot; , &quot;create&quot; , &quot;update&quot; , &quot;patch&quot; , &quot;delete&quot; ] } ) ] end end MySecondResourceController . rbac_rules ( )","ref":"controllers.html#rbac-rules"},{"type":"extras","title":"CRD Versions","doc":"Mix . install ( [ :bonny ] ) Application . put_env ( :bonny , :operator_name , &quot;livebook-operator&quot; )","ref":"crd_versions.html"},{"type":"extras","title":"CRD Versions - CRD Definition and Versions","doc":"When defining your operator ( use Bonny.Operator ), you have to implement the callback crds/0 where you define your custom resources. A custom resource definition (CRD) is represented by a %Bonny.API.CRD{} struct which defines 4 fields: :scope - either :Namespaced or :Cluster :group - The API group of your controller / this resource :names - A map with 3-4 keys defining the names of this resource. plural : name to be used in the URL: /apis/&lt;group&gt;/&lt;version&gt;/&lt;plural&gt; - e.g. crontabs singular : singular name to be used as an alias on the CLI and for display - e.g. crontab kind : is normally the CamelCased singular type. Your resource manifests use this. - e.g. CronTab shortnames : allow shorter string to match your resource on the CLI - e.g. [ct] versions : list of API Version modules for this Resource, defaults to the versions in config.exs defmodule MyOperator.Operator do use Bonny.Operator , default_watch_namespace : &quot;default&quot; step ( :delegate_to_controller ) def controllers ( _watching_namespace , _opts ) , do : [ ] def crds ( ) do [ % Bonny.API.CRD { names : %{ kind : &quot;CronTab&quot; , plural : &quot;crontabs&quot; , shortNames : [ &quot;ct&quot; ] , singular : &quot;crontab&quot; } , group : &quot;example.com&quot; , versions : [ MyOperator.API.V1.CronTab ] , scope : :Namespaces } ] end end We're going to look at version manifest declaration in more detail in just a moment. For now, let's just define a simple API version v1 for the CronTab custom resource with just defaults for all the fields. You do this by defining a module that starts with the API declared in the application configuration ( YourOperator.API.V1 ), followed by the CRD name ( CronTab ). The module must use Bonny.API.Version which expects you to implement manifest/0 . defmodule MyOperator.API.V1.CronTab do use Bonny.API.Version @impl Bonny.API.Version def manifest ( ) do defaults ( ) |&gt; struct! ( name : &quot;v1&quot; , storage : true ) end end YourOperator.API.V1.CronTab . manifest ( ) Now, if we define a CronTabController , Bonny finds this version and add it to the CRD manifest. crds = [ MyOperator.Operator ] |&gt; Bonny.Mix.Operator . crds ( ) |&gt; Ymlr . documents! ( ) IO . puts ( crds )","ref":"crd_versions.html#crd-definition-and-versions"},{"type":"extras","title":"CRD Versions - Version Manifest Declaration","doc":"Our V1.CronTab module called the defaults/0 macro from manifest/0 . This macro helps initializing a generic version with no schema, subresources or additional printer columns. The storage flag is set to false (see Multi-Version APIs further down). For the other flags :served and :deprecated such as the field :deprecatedWarning , assumptions are made. An operator run in production might want to define at least a :schema , probably :additionalPrinterColumns and maybe :subresources . All these fields such as flags can be overriden in manifest/0 . defmodule YourOperator.API.V1Alpha1.Widget do use Bonny.API.Version @impl true def manifest ( ) do struct! ( defaults ( ) , storage : true , schema : %{ openAPIV3Schema : %{ type : :object , properties : %{ spec : %{ type : :object , properties : %{ foos_requested : %{ type : :integer } } } , status : %{ type : :object , properties : %{ foos_implemented : %{ type : :integer } } } } } } , additionalPrinterColumns : [ %{ name : &quot;requested_foos&quot; , type : :integer , description : &quot;Number of foos requested&quot; , jsonPath : &quot;.spec.foos_requested&quot; } , %{ name : &quot;implemented_foos&quot; , type : :integer , description : &quot;Number of foos implemented&quot; , jsonPath : &quot;.status.foos_implemented&quot; } ] , subresources : %{ status : %{ } } ) end end YourOperator.API.V1Alpha1.Widget . manifest ( )","ref":"crd_versions.html#version-manifest-declaration"},{"type":"extras","title":"CRD Versions - The Status Subresource","doc":"In the controllers guide we explain the importance of using of the status subresource. In order to use the status subresource, it has to be enabled and its schema has to be defined in the CRD. You can see an example in the code snipped above in the YourOperator.API.V1Alpha1.Widget . Two special use cases of the status subresource are skipping obeserved generations and conditions . In order to use these concepts with custom resources, they have to be configured on the CRD. When use ing Bonny.API.Version , helper functions add_observed_generation_status/1 and add_conditions/1 are imported to your module. Use them to add the required fields to your manifest: defmodule YourOperator.API.V1Alpha1.Feature do use Bonny.API.Version @impl true def manifest ( ) do defaults ( ) |&gt; struct! ( schema : %{ # your openAPIV3schema } ) # initialize the usage of the observed generations pluggable step |&gt; add_observed_generation_status ( ) # initialize the usage of conditions. |&gt; add_conditions ( ) end end YourOperator.API.V1Alpha1.Widget . manifest ( )","ref":"crd_versions.html#the-status-subresource"},{"type":"extras","title":"CRD Versions - Multi-Version APIs","doc":"There is some documentation about multi-version apis for the kubebuilder. Obviousely, that one is for creating a kubernetes controller in Go, but it's a good read nontheless. This is how it begins: Most projects start out with an alpha API that changes release to release. However, eventually, most projects will need to move to a more stable API. Once your API is stable though, you can't make breaking changes to it. That's where API versions come into play. Conversion Webhooks are currently not implemented in Bonny. There is the module bonny_plug that can be used to implement them. There might be a neater integration of the two in the future, though. Bonny already lets you define a version as the hub . The only thing this does right now is it sets the storage flag to true in the generated manifest. defmodule YourOperator.API.V1.CronTab do use Bonny.API.Version , hub : true @impl Bonny.API.Version # storage: true not needed here. def manifest ( ) , do : defaults ( name : &quot;v1&quot; ) end YourOperator.API.V1.CronTab . manifest ( ) Storage Versions Even if you define multiple versions for the same resource, Kubernetes is only going to store the data in one version - the storage version . Note that multiple versions may exist in storage if they were written before the storage version changes -- changing the storage version only affects how objects are created/updated after the change. As mentioned above, there are to ways to define the storage version, by passing hub: true as an option to use Bonny.API.Version or by setting storage: true in manifest/0 .","ref":"crd_versions.html#multi-version-apis"},{"type":"extras","title":"Testing","doc":"Mix . install ( [ :bonny , :inflex ] ) Application . put_env ( :bonny , :operator_name , &quot;livebook-operator&quot; ) ExUnit . start ( autorun : false )","ref":"testing.html"},{"type":"extras","title":"Testing - The Controller to Test","doc":"In this guide we're going to create a simple controller and write a test for it. The controller's custom resource is called ConfigMapToPluralize and we expect the controller to map the resource to a ConfigMap on the cluster. The ConfigMap should contain the same fields as the ConfigMapToPluralize but the fielt's values are pluralized. Example For the following ConfigMapToPluralize resource: apiVersion: example.com/v1 kind: ConfigMapToPluralize metadata: name: foo namespace: default data: first: House second: Hero the controller will create the following ConfigMap : apiVersion: v1 kind: ConfigMap metadata: name: foo namespace: default data: first: Houses second: Heroes The CRD API V1 Let's define the API version V1 for the ConfigMapToPluralize CRD. It defines a schema with a property .data which is an object allowing for arbitrary fields with string values. defmodule V1.ConfigMapToPluralize do use Bonny.API.Version , hub : true def manifest ( ) do struct! ( defaults ( ) , schema : %{ openAPIV3Schema : %{ type : :object , properties : %{ data : %{ type : :object , additionalProperties : %{ type : :string } , &quot;x-kubernetes-preserve-unknown-fields&quot; : true } } } } ) end end The Controller The ConfigMapToPluralizeController handles :add and :modify and :reconcile events through the same function where the ConfigMap with pluralized field values is created and registered as descendant. defmodule ConfigMapToPluralizeController do use Bonny.ControllerV2 step :handle_event def handle_event ( % Bonny.Axn { action : action } = axn , _opts ) when action in [ :add , :modify , :reconcile ] do % Bonny.Axn { resource : resource } = axn name = K8s.Resource.FieldAccessors . name ( resource ) namespace = K8s.Resource.FieldAccessors . namespace ( resource ) new_data = resource |&gt; Map . get ( &quot;data&quot; ) |&gt; Enum . map ( fn { key , value } -&gt; { key , Inflex . pluralize ( value ) } end ) |&gt; Enum . into ( %{ } ) cm = %{ &quot;apiVersion&quot; =&gt; &quot;v1&quot; , &quot;kind&quot; =&gt; &quot;ConfigMap&quot; , &quot;metadata&quot; =&gt; %{ &quot;name&quot; =&gt; name , &quot;namespace&quot; =&gt; namespace } , &quot;data&quot; =&gt; new_data } axn |&gt; register_descendant ( cm ) |&gt; success_event ( ) end def handle_event ( axn , _opts ) do # since we added the owner reference above, there&#39;s nothing to do here. # Kubernetes will delete the referencing objects i.e. the ConfigMap for us. success_event ( axn ) end end","ref":"testing.html#the-controller-to-test"},{"type":"extras","title":"Testing - Testing the controller","doc":"Testing a Bonny controller is similar to testing a Phoenix controller. Controllers use the %Bonny.Axn{} token to register descending resources, update resource status and registering Kubernetes events. In our test, we need to assert the state of the returned Bonny.Axn{} struct is as expected. Helper Module Bonny.Axn.Test Bonny.Axn.Test is a helper module for tests. It provides a function axn/2 to create a %Bonny.Axn{} token and other helper functions which are imported to your test when using the helper module. defmodule ConfigMapToPluralizeControllerTest do use ExUnit.Case , async : true use Bonny.Axn.Test #  Module Under Test alias ConfigMapToPluralizeController , as : MUT setup do cm_to_pluralize = %{ &quot;apiVersion&quot; =&gt; &quot;example.com/v1&quot; , &quot;kind&quot; =&gt; &quot;ConfigMapToPluralize&quot; , &quot;metadata&quot; =&gt; %{ &quot;namespace&quot; =&gt; &quot;default&quot; , &quot;name&quot; =&gt; &quot;test-1&quot; } , &quot;data&quot; =&gt; %{ &quot;first&quot; =&gt; &quot;House&quot; , &quot;second&quot; =&gt; &quot;Hero&quot; } } [ axn : axn ( :add , resource : cm_to_pluralize , conn : % K8s.Conn { } ) ] end test &quot;registers descending ConfigMap with pluralized fields&quot; , %{ axn : axn } do assert [ cm ] = axn |&gt; MUT . call ( [ ] ) |&gt; descendants ( ) assert &quot;Houses&quot; == cm [ &quot;data&quot; ] [ &quot;first&quot; ] assert &quot;Heroes&quot; == cm [ &quot;data&quot; ] [ &quot;second&quot; ] end test &quot;registers a success event&quot; , %{ axn : axn } do assert [ event ] = axn |&gt; MUT . call ( [ ] ) |&gt; events ( ) assert :Normal == event . event_type end end ExUnit . run ( )","ref":"testing.html#testing-the-controller"},{"type":"extras","title":"Testing - Integration Testing","doc":"You can also test your code against a real Kubernetes cluster setup locally (e.g. with k3d ) and in your CI. You will need to setup a %K8s.Conn{} defines the connection your cluster but is oonly used for the integration tests . Have a look at the follwing files in the Bonny repo: test/support/integration_helper.ex - defines a conn/0 function test/bonny/controller_v2_integration_test.exs - implements integration tests using the helper above.","ref":"testing.html#integration-testing"},{"type":"extras","title":"The Operator","doc":"Mix . install ( [ :kino , :bonny ] ) defmodule MyApp.API.V1.TestResource do use Bonny.API.Version def manifest ( ) , do : defaults ( ) end defmodule MyApp.Controller.GenericController do use Bonny.ControllerV2 step :handle_event def handle_event ( axn , _ ) , do : axn end Logger . configure ( level : :info )","ref":"the_operator.html"},{"type":"extras","title":"The Operator - About this Livebook","doc":"This livebook connects to a kubernetes cluster. Please define here the connection to a cluster you have access to: { :ok , conn } = K8s.Conn . from_file ( &quot;~/.kube/config&quot; , context : &quot;k3d-bonny-ex&quot; )","ref":"the_operator.html#about-this-livebook"},{"type":"extras","title":"The Operator - The Operator","doc":"The operator defines custom resources, watch queries and their controllers and serves as the entry point to the watching and handling processes. Overall, an operator has the following responsibilities: to provide a wrapper for starting and stopping the operator as part of a supervision tree To define the resources to be watched together with the controllers which handle action events on those resources. to define an initial pluggable pipeline containing the step :delegate_to_controller for all action events to pass through To define any custom resources ending up in the manifest generated by mix bonny.gen.manifest defmodule MyApp.Operator do use Bonny.Operator , default_watch_namespace : &quot;default&quot; @impl Bonny.Operator def crds ( ) do [ % Bonny.API.CRD { group : &quot;example.com&quot; , scope : :Namespaced , names : Bonny.API.CRD . kind_to_names ( &quot;MyCustomResource&quot; ) , versions : [ MyApp.API.V1.TestResource ] } ] end step :delegate_to_controller step Bonny.Pluggable.ApplyStatus step Bonny.Pluggable.ApplyDescendants @impl Bonny.Operator def controllers ( watching_namespace , _opts ) do [ %{ query : K8s.Client . watch ( &quot;example.com/v1&quot; , &quot;MyCustomResource&quot; , namespace : watching_namespace ) , controller : MyApp.Controller.GenericController } , %{ query : K8s.Client . watch ( &quot;apps/v1&quot; , &quot;Deployment&quot; , namespace : watching_namespace ) , controller : MyApp.Controller.GenericController } ] end end","ref":"the_operator.html#the-operator"},{"type":"extras","title":"The Operator - The crds/0 Callback","doc":"By implementing the crds/0 callback, you tell Bonny what custom resources your operator defines. It is read only when running mix bonny.gen.manifest in order to generate the operator manifest: crds = [ MyApp.Operator ] |&gt; Bonny.Mix.Operator . crds ( ) |&gt; Ymlr . documents! ( ) IO . puts ( crds ) In order to run the operator in this livebook, we have to apply the CRD to the cluster. This step has nothing to do with the operator directly. We just do it in order to run the operator. crds |&gt; YamlElixir . read_all_from_string! ( ) |&gt; Bonny.Resource . apply_async ( conn , field_manager : &quot;livebook&quot; ) |&gt; Enum . each ( fn { _ , { :ok , applied_crd } } -&gt; dbg ( applied_crd ) end )","ref":"the_operator.html#the-crds-0-callback"},{"type":"extras","title":"The Operator - The controllers/2 Callback","doc":"In controllers/2 we define the queries and their event handlers, i.e. controllers. function should return a list where each element of the list is a map with these 2 keys: :query - A list operation of type K8s.Operation.t() . Bonny will watch the cluster with this operation and forward all events to the :controller . :controller - A controller (See the controller guide ) or any other Pluggable step. Accepts a module or a {controller :: module(), init_opts :: keyword()} tuple. If a tuple is given, the init_opts are passed to the controller's init/1 function. If you managed to define a valid conn above, you can now run the operator defined above in this livebook. The code below starts the operator and shows the supervision tree. Note how the operator starts an EventRecorder and two proceses for each controller defined in controllers/2 . These two processes are the Watcher and the Reconciler . The Watcher watches for ADD , MODIFY and DELETE events in the cluster. The Reconciler regularly creates :reconcile events for each resource found in the cluster. { :ok , supervisor } = Supervisor . start_link ( [ { MyApp.Operator , conn : conn } ] , strategy : :one_for_one ) Kino.Process . render_sup_tree ( supervisor )","ref":"the_operator.html#the-controllers-2-callback"},{"type":"extras","title":"The Operator - Adding the Operator to your Supervisor","doc":"Once your operator is implemented, you need to add it to your application supervision tree. You can pass :conn and :watch_namespace as init arguments if you like. If you don't pass them, :conn will be retrieved from the callback in your config.exs and :watch_namespace will fall back to the :default_watch_namespace you configured your operator with. defmodule MyOperator.Application do use Application def start ( _type , env : env ) do children = [ { MyOperator.Operator , conn : MyOperator.K8sConn . get! ( env ) , watch_namespace : :all } ] opts = [ strategy : :one_for_one , name : MyOperator.Supervisor ] Supervisor . start_link ( children , opts ) end end","ref":"the_operator.html#adding-the-operator-to-your-supervisor"},{"type":"extras","title":"The Operator - Leader Election - Running Multiple Replicas","doc":"From https://docs.okd.io/latest/operators/operator_sdk/osdk-leader-election.html : During the lifecycle of an Operator, it is possible that there may be more than one instance running at any given time, for example when rolling out an upgrade for the Operator. In such a scenario, it is necessary to avoid contention between multiple Operator instances using leader election. This ensures only one leader instance handles the reconciliation while the other instances are inactive but ready to take over when the leader steps down. In other words, if you want to run multiple replicas of your oprator, you need to turn on leader election. Leader election is enabled per default. To disable it, you have to pass the enable_leader_election: false option when adding the operator to your Supervisor : defmodule MyOperator.Application do use Application def start ( _type , env : env ) do children = [ { MyOperator.Operator , conn : MyOperator.K8sConn . get! ( env ) , watch_namespace : :all , enable_leader_election : false } # &lt;-- disables the leader elector ] opts = [ strategy : :one_for_one , name : MyOperator.Supervisor ] Supervisor . start_link ( children , opts ) end end","ref":"the_operator.html#leader-election-running-multiple-replicas"},{"type":"extras","title":"The Operator - Pluggable Pipeline and Steps","doc":"The operator implements a Pluggable pipeline, the controller represents one step in this pipeline but can contain sub-steps as well. Bonny comes with a few steps to your convenience. In most caes it makes sense to add at least Bonny.Pluggable.ApplyDescendants and Bonny.Pluggable.ApplyStatus to the end of your operator pipeline. Bonny.Pluggable.AddManagedByLabelToDescendants - Adds the app.kubernetes.io/managed-by label to all descendants registered within the pipeline. Bonny.Pluggable.AddMissingGVK - Add fields apiVersion and kind to the resource if they are missing. Bonny.Pluggable.ApplyDescendants - applies all the descendants added to the %Bonny.Axn{} struct. Bonny.Pluggable.ApplyStatus - applies the status of the given %Bonny.Axn{} struct to the status subresource. Bonny.Pluggable.Finalizer - declares a finalizer and its implementation. Bonny.Pluggable.Logger - logs an action event and when status, descendants and events are applied to the cluster. If desired, it makes sense to be placed as first step in your operator pipeline but can also be added to a controller pipeline. Bonny.Pluggable.SkipObservedGenerations - halts the pipelines for a defined list of actions if the observed generation equals the resource's generation. You'll find further documentation on this module in the Controller guide.","ref":"the_operator.html#pluggable-pipeline-and-steps"},{"type":"extras","title":"Contributing","doc":"Contributing to Bonny is as easy as opening a PR. Please make sure your code is tested and add a Changelog.","ref":"contributing.html"},{"type":"extras","title":"Contributing - Testing","doc":"If you're writing tests, you might also want to check out the k8s library testing guide . Integration Testing A Makefile is included for help with integration testing against k3d. You're gonna need k3d installed on your machine to run integration tests. Run make help for a list of commands: test . integration Run integration tests using k3d ` make cluster ` test . watch Run all tests with mix . watch test Run all tests Integration environment variables TEST_KUBECONFIG path to kubeconfig file for integration tests, default: &quot;./integration.yaml&quot;","ref":"contributing.html#testing"},{"type":"extras","title":"Migrations","doc":"","ref":"migrations.html"},{"type":"extras","title":"Migrations - Migrating from 0.5 to a newer version","doc":"In this version of, Bonny comes with slightly a new concept. In this version you have to define an operator and add it to your application's supervision tree. Also, the processing of events are done in a Plug-like pipeline leveraging the Pluggable library. This makes controllers easeir to test but also easier to customize. See for yourself. Option 1: Use mix bonny.init on a fresh project The probably easiest way is to start with a plain Elixir project and set up your operator using mix bonny.init . Since you already know what resources and controllers you need, this will initiate your operator, CRDs, versions and controllers for you. You just have to copy your controller implementation over to the generated controllers and bring it into a Pluggable form. Option 2: Manual migration Step 1: Create your Opeator Create a new module (e.g. YourProject.Operator ) which uses use Bonny.Operator , implement crds/0 and controllers/2 according to the Operator Guide and add it to your supervision tree. Step 2: Create your API versions For each custom resource your operator defines and each version the resource supports, create the corresponding module: # lib/your_operator/api/v1/cron_tab.ex defmodule YourOperator.API.V1.CronTab do use Bonny.API.Version @impl Bonny.API.Version def manifest ( ) , do : struct! ( defaults ( ) , storage : true ) end # lib/your_operator/api/v1alpha1/cron_tab.ex defmodule YourOperator.API.V1Alpha1.CronTab do use Bonny.API.Version @impl Bonny.API.Version def manifest ( ) , do : defaults ( ) end Note that one and only one version of the same custom resource has to be flagged with storage: true . Step 3: Additional Printer Columns Additional printer columns belong to CRD API versions, not to controllers. Therefore, if your controller defined additional printer columns, move those over to the version you just created. Modify manifest/0 for this purpose. # lib/your_operator/api/v1/cron_tab.ex defmodule YourOperator.API.V1Alpha1.CronTab do use Bonny.API.Version @impl Bonny.API.Version def manifest ( ) do struct! ( defaults ( ) , additionalPrinterColumns : [ %{ name : &quot;foos&quot; , type : :integer , description : &quot;Number of foos&quot; , jsonPath : &quot;.spec.foos&quot; } ] ) end end Step 4: Update your Controllers Also see the Controllers Guide Change use Bonny.Controller to use Bonny.ControllerV2 If you have defined additional RBAC rules via @rule {apiGroup, resources_list, verbs_list} , implement the rbac_rules/0 . If you have defined custom names via @names %{...} , the resource scope (e.g. @scope :cluster ) or an API group (e.g. @group &quot;example.com&quot; ), add these values to the CRD in your Operator (see above) Bring your controller to a Pluggable form. See the Controllers Guide After having migrated all controllers, re-generate your manifest using mix bonny.gen.manifest .","ref":"migrations.html#migrating-from-0-5-to-a-newer-version"},{"type":"extras","title":"Migrations - Migrating from 0.4 to 0.5","doc":"Version 0.5 comes with some major changes. Please read through this migration guide before upgrading. Elixir Version With version 0.5, bonny moved Elixir support from \\~&gt; 1.9 to \\~&gt; 1.10. Config The dependency on :k8s was upgraded from ~&gt; 0.4.0 to ~&gt; 1.1 . With version 1.0 , :k8s brought some major changes. Mainly the way the connection to the cluster is configured. While pre 1.0 , connections were configured in config.exs , in 1.0 upwards, they had to created and passed to the client by the caller. This change affects :bonny , too. Starting with version 0.5 , you no longer have to configure :k8s . This means you can remove this block completely as it has no effect: config :k8s , clusters : ... With 0.5 , :bonny however has to be configured with a new option :get_conn . The value of this configuration option is supposed to be an MFA tuple that tells bonny how to get the connection struct. The function is called by bonny and is expected to return either {:ok, K8s.Conn.t()} or a K8s.Conn.t() directly. config :bonny , get_conn : { MyModule , :get_the_connection } , You can use helpers defined in :k8s to get the connection: config :bonny , get_conn : { K8s.Conn , :from_file , [ &quot;~/.kube/config&quot; , [ context : &quot;optional-alternate-context&quot; ] ] } , or, when configuring bonny to run in your cluster: config :bonny , get_conn : { K8s.Conn , :from_service_account , [ ] }","ref":"migrations.html#migrating-from-0-4-to-0-5"},{"type":"extras","title":"Bonny Mix Tasks","doc":"There are a number of mix tasks to help create a Kubernetes operator. mix help | grep bonny","ref":"mix_tasks.html"},{"type":"extras","title":"Bonny Mix Tasks - Initialize your Operator (mix bonny.init)","doc":"To add bonny to your existing elixir project ( mix new your_operator ), this tasks helps you to generate application configuration and initializing your test suite. Just run mix bonny.init , the task will ask you questions about your operator and initialize it.","ref":"mix_tasks.html#initialize-your-operator-mix-bonny-init"},{"type":"extras","title":"Bonny Mix Tasks - Controller Generation (mix bonny.gen.controller)","doc":"Guides you through the creation of a controller. Normally, a controller of an operator watches a custom resource defined by that same operator. This is the default flow through this mix task. However, you can also create a controller that watches and reacts on events of core resources or custom resources defined by another operator. See the controllers guide for further information about controllers. After the mix task ran through, open up your controller and add functionality for your resource's lifecycles: Apply (or Add/Modify) Delete Reconcile; periodically called with each every instance of a CRD's resources Ideally you'd also open up the generated CRD versions and add OpenAPIV3 schema, additional printer columns, etc. Your operator can also have multiple controllers if you want to watch multiple resources in your operator. Just run the mix task again. Generating Kubernetes manifest for operator ( mix bonny.gen.manifest ) This will generate the entire manifest for this operator including: CRD manifests RBAC Service Account Operator Deployment The operator manifest generator requires the image flag to be passed if you plan to deploy the operator in your cluster. This is the docker image URL of your operators docker image created by mix bonny.gen.docker above. mix bonny.gen.manifest --image ${BONNY_IMAGE} You may omit the --image flag if you want to generate a manifest without the deployment so that you can develop locally running the operator outside of the cluster. By default the manifest will generate the service account and deployment in the &quot;default&quot; namespace. To set the namespace explicitly: mix bonny.gen.manifest --out - -n test Alternatively you can apply it directly to kubectl : mix bonny.gen.manifest --out - -n test | kubectl apply -f - -n test Generating a dockerfile ( mix bonny.gen.dockerfile ) The following command will generate a dockerfile for your operator . This will need to be pushed to a docker repository that your Kubernetes cluster can access. Again, this Dockerfile is for your operator, not for the pods your operator may deploy. You can skip this step when developing by running your operator external to the cluster. mix bonny.gen.dockerfile export BONNY_IMAGE=YOUR_IMAGE_NAME_HERE docker build -t ${BONNY_IMAGE} . docker push ${BONNY_IMAGE}:latest","ref":"mix_tasks.html#controller-generation-mix-bonny-gen-controller"}]